Package: Basic4Cseq
Type: Package
Title: Basic4Cseq: an R/Bioconductor package for analyzing 4C-seq data
Version: 1.49.0
Date: 2025-06-27
Author: Carolin Walter
Maintainer: Carolin Walter <carolin.walter@uni-muenster.de>
Imports: methods, RCircos, BSgenome.Ecoli.NCBI.20080805
Depends: R (>= 3.5.0), Biostrings, GenomicAlignments, caTools,
        GenomicRanges, grDevices, graphics, stats, utils
Suggests: BSgenome.Hsapiens.UCSC.hg19
Description: Basic4Cseq is an R/Bioconductor package for basic
    filtering, analysis and subsequent visualization of 4C-seq
    data. Virtual fragment libraries can be created for any
    BSGenome package, and filter functions for both reads and
    fragments and basic quality controls are included. Fragment
    data in the vicinity of the experiment's viewpoint can be
    visualized as a coverage plot based on a running median
    approach and a multi-scale contact profile.
License: LGPL-3
biocViews: ImmunoOncology, Visualization, QualityControl, Sequencing,
        Coverage, Alignment, RNASeq, SequenceMatching, DataImport
git_url: https://git.bioconductor.org/packages/Basic4Cseq
git_branch: devel
git_last_commit: e0189bb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-05-18
NeedsCompilation: no
Packaged: 2026-05-18 21:18:11 UTC; biocbuild
Built: R 4.6.0; ; 2026-05-19 04:42:48 UTC; unix

.getReadDistribution <- function(expData, distanceFromVP = 100000, useFragEnds = TRUE, outputName = "") {

    coordinatesVP = viewpointInterval(expData)

    fragmentData = subset(rawFragments(expData), rawFragments(expData)$chromosomeName == viewpointChromosome(expData) & (rawFragments(expData)$fragmentEnd < coordinatesVP[1] | rawFragments(expData)$fragmentStart > coordinatesVP[2]))
    vpAreaFragments = subset(fragmentData, (fragmentData$fragmentStart >= coordinatesVP[1]-distanceFromVP & fragmentData$fragmentEnd <= coordinatesVP[2]+distanceFromVP))

    vpAreaFragments <- formatFragmentData(vpAreaFragments, useFragEnds)

    # filter invalid reads
    readsTotal = subset(rawReads(expData), !(is.na(start(rawReads(expData)))))

    # get cis reads
    readsVPChrom = subset(readsTotal, as.character(seqnames(readsTotal)) == viewpointChromosome(expData))

    # prepare region for viewpoint region read control
    maxLeft = coordinatesVP[1] - distanceFromVP
    maxRight = coordinatesVP[2] + distanceFromVP

    readsVPRegion = subset(readsVPChrom, start(readsVPChrom) >= maxLeft & end(readsVPChrom) <= maxRight)

    percentageChrom = round(length(readsVPChrom) / length(readsTotal) * 100, digits = 2)
    percentageVP = round(length(readsVPRegion) / length(readsTotal) * 100, digits = 2)

    coveredReadFragments = subset(vpAreaFragments, vpAreaFragments$reads != 0)

    percentageCov = round(nrow(coveredReadFragments) / nrow(vpAreaFragments) * 100, digits = 2)

    readsTotalText = paste("total reads:", length(readsTotal), sep = " ")
    readsVPChromText = paste("reads on the viewpoint chromosome: ", length(readsVPChrom), " (", percentageChrom, "% of total reads)", sep = "")
    readsVPRegionText = paste("reads in the viewpoint region: ", length(readsVPRegion), " (", percentageVP, "% of total reads)", sep = "")
    coverageVPRegionText = paste("covered fragment ends in the viewpoint region: ", percentageCov, "%", sep = "")

    statistics = paste(readsTotalText, readsVPChromText, readsVPRegionText, coverageVPRegionText, sep = "\n")

    if (outputName == "") {
        print(readsTotalText)
        print(readsVPChromText)
        print(readsVPRegionText)
        print(coverageVPRegionText)
    } else {
        fileConn = file(outputName)
        writeLines(statistics, fileConn)
        close(fileConn)
    }
}




setMethod("getReadDistribution",
    signature=signature(expData="Data4Cseq"),
    .getReadDistribution)

.chooseNearCisFragments <- function(expData, regionCoordinates, deleteViewpoint = TRUE) {

    fragmentData = rawFragments(expData)

    # for cis-interactions: only consider viewpoint chromosome
    fragmentData <- subset(fragmentData, fragmentData$chromosomeName == viewpointChromosome(expData))

    # delete viewpoint fragments, if chosen (default: TRUE)
    if (deleteViewpoint) {
        fragmentData = subset(fragmentData, (fragmentData$fragmentEnd < viewpointInterval(expData)[1] | fragmentData$fragmentStart > viewpointInterval(expData)[2]))
    }

    # pick relevant fragments for visualization range
    relevantFragments = (subset(fragmentData, (fragmentData$fragmentStart >= regionCoordinates[1] & fragmentData$fragmentEnd <= regionCoordinates[2])))

    return(relevantFragments)  
}




setMethod("chooseNearCisFragments",
    signature=signature(expData="Data4Cseq", regionCoordinates="numeric"),
    .chooseNearCisFragments)

.printBEDFragmentLibrary <- function(fragmentLibrary, BEDLibraryName, minFragEndLength = 0, zeroBased = FALSE) {

    allFragments = read.table(fragmentLibrary, header = TRUE)
    
    # relevant fragments: all fragments with at least one relevant (i.e. unique and of sufficient length) frag end 
    relevantFragments = subset(allFragments, ((allFragments$leftFragEndLength >= minFragEndLength) & (allFragments$leftFragEndValid == TRUE)) | ((allFragments$rightFragEndLength >= minFragEndLength) & (allFragments$rightFragEndValid == TRUE)) )

    if (zeroBased) {
        relevantFragments$fragmentStart = relevantFragments$fragmentStart - 1
    }

    write.table(relevantFragments[,1:3], file = BEDLibraryName, sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
}




setMethod("printBEDFragmentLibrary",
    signature=signature(fragmentLibrary="character", BEDLibraryName="character"),
    .printBEDFragmentLibrary)

.simulateDigestion_Character <- function(firstCutter, secondCutter, dnaSequence) {

    fragmentSequencesFirstDigestion = unlist(strsplit(dnaSequence, split=toupper(firstCutter)))
    fragmentSequencesSecondDigestion = unlist(strsplit(fragmentSequencesFirstDigestion, split=toupper(secondCutter)))
    fragmentLengths = as.data.frame(table(nchar(fragmentSequencesSecondDigestion)))
    colnames(fragmentLengths) = c("length", "frequency")
    return(fragmentLengths)
}


.simulateDigestion_BSgenome <- function(firstCutter, secondCutter, dnaSequence) {

    chromosomeNames = seqnames(dnaSequence)
    totalFragments = NULL

    for (i in 1:length(chromosomeNames)) {
        chromosomeToSplit = dnaSequence[[i]]
        currentChromosomeFragments = simulateDigestionChromosome(firstCutter, secondCutter, chromosomeToSplit)
        totalFragments = c(totalFragments, currentChromosomeFragments)
    }

    fragmentLengths = as.data.frame(table(nchar(totalFragments)))
    colnames(fragmentLengths) = c("length", "frequency")
    return(fragmentLengths)
}


.simulateDigestionChromosome_MaskedDNAString <- function(firstCutter, secondCutter, dnaSequence) {

    dnaSequence = toString(as(unmasked(dnaSequence), "Views"))
    fragmentSequencesFirstDigestion = unlist(strsplit(dnaSequence, split=toupper(firstCutter)))
    fragmentSequencesSecondDigestion = unlist(strsplit(fragmentSequencesFirstDigestion, split=toupper(secondCutter)))

    return(fragmentSequencesSecondDigestion)
}


.simulateDigestionChromosome_DNAString <- function(firstCutter, secondCutter, dnaSequence) {

    dnaSequence = toString(dnaSequence)
    fragmentSequencesFirstDigestion = unlist(strsplit(dnaSequence, split=toupper(firstCutter)))
    fragmentSequencesSecondDigestion = unlist(strsplit(fragmentSequencesFirstDigestion, split=toupper(secondCutter)))

    return(fragmentSequencesSecondDigestion)
}


.drawDigestionFragmentHistogram <- function(fragments, minLength = 0, maxLength = 10000) {

    fragmentData = subset(fragments, as.numeric(fragments$length) >= minLength & as.numeric(fragments$length) <= maxLength)
    plot(as.vector(fragmentData$length), as.vector(fragmentData$frequency), type = "h", main = "Fragment frequencies", lty = 1, xlab = "length", ylab = "frequency")
}


setMethod("simulateDigestion",
    signature=signature(firstCutter="character", secondCutter="character", dnaSequence="character"),
    .simulateDigestion_Character)

setMethod("simulateDigestion",
    signature=signature(firstCutter="character", secondCutter="character", dnaSequence="BSgenome"),
    .simulateDigestion_BSgenome)

setMethod("simulateDigestionChromosome",
    signature=signature(firstCutter="character", secondCutter="character", dnaSequence="MaskedDNAString"),
    .simulateDigestionChromosome_MaskedDNAString)

setMethod("simulateDigestionChromosome",
    signature=signature(firstCutter="character", secondCutter="character", dnaSequence="DNAString"),
    .simulateDigestionChromosome_DNAString)

setMethod("drawDigestionFragmentHistogram",
    signature=signature(fragments="data.frame"),
    .drawDigestionFragmentHistogram)

.readsToFragments <- function(expData, fragmentLib) {

    readsTotal = rawReads(expData)
    # check all chromosomes where reads are present
    chromosomeNames = unique(as.vector(seqnames(readsTotal)))

    # read fragment data (with  meta data, like uniqueness of frag-ends + second cutter site)
    fragmentTableTotal = read.table(fragmentLib, header = TRUE)
    
    fragmentDataTotal = NULL
    
    for (i in 1:length(chromosomeNames)) {

        reads = subset(readsTotal, as.character(seqnames(readsTotal)) == chromosomeNames[i])

        readsPlus = subset(reads, as.character(strand(reads)) == "+")
        readsMinus = subset(reads, as.character(strand(reads)) == "-")

        if (length(readsPlus) > 0 & length(readsMinus) > 0) {

            baseCovPlus = as.numeric(coverage(readsPlus)[[chromosomeNames[i]]])
            baseCovMinus = as.numeric(coverage(readsMinus)[[chromosomeNames[i]]])

            fragmentTable = subset(fragmentTableTotal, fragmentTableTotal$chromosomeName == chromosomeNames[i])

            # add zeroes if last fragment is not covered
            tempPlus = fragmentTable[nrow(fragmentTable),3] - length(baseCovPlus)
            if (tempPlus < 0) {
                tempPlus = 0
            }
            baseCovPlus = c(baseCovPlus,  rep(0, times=tempPlus))
            tempMinus = fragmentTable[nrow(fragmentTable),3] - length(baseCovMinus)
            if (tempMinus < 0) {
                tempMinus = 0
            }
            baseCovMinus = c(baseCovMinus,  rep(0, times=tempMinus))

            if (fragmentTable$fragmentEnd[1] == 0) {
                fragmentTable$fragmentEnd[1] = 1
            }

            # calculate read count for fragment start, end, and average
            leftFragEndReads = baseCovPlus[fragmentTable$fragmentStart]
            rightFragEndReads = baseCovMinus[fragmentTable$fragmentEnd]
            fragEndReadsAverage = round((leftFragEndReads + rightFragEndReads) / 2)

            fragmentData = data.frame(fragmentTable, leftFragEndReads, rightFragEndReads, fragEndReadsAverage)
            fragmentDataTotal = rbind(fragmentDataTotal, fragmentData)
        }
    }

    return(fragmentDataTotal)  
}




setMethod("readsToFragments",
    signature=signature(expData="Data4Cseq", fragmentLib="character"),
    .readsToFragments)

.drawHeatmap_Data4Cseq <- function(expData, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE) {

    fragsToVisualize = formatFragmentData(expData, useFragEnds)

    drawHeatmapMain(fragsToVisualize, plotFileName, smoothingType, picDim, bands, cutoffLog, xAxisIntervalLength, legendLabels, useFragEnds)
}


.drawHeatmap_DataFrame <- function(expData, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE) {

    fragsToVisualize = expData

    if (!useFragEnds) {
        print("drawHeatmap: use of fragment-wise interpolated data not possible for data frame input")
    }

    drawHeatmapMain(fragsToVisualize, plotFileName, smoothingType, picDim, bands, cutoffLog, xAxisIntervalLength, legendLabels, useFragEnds)
}


.drawHeatmapMain <- function(fragsToVisualize, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE) {

    position = round((fragsToVisualize$start + fragsToVisualize$end) / 2)
    averageReads = fragsToVisualize$reads

    # prepare heatmap-like data (varied window lengths for running mean / running median)
    signal = matrix(0, bands, nrow(fragsToVisualize))

    for (i in 1:bands) {

        wl = i * 2 - 1

        if (smoothingType == "median") {
            # smoothed data (median with defined window length)
            signal[i,] = runmed(averageReads, wl, endrule = "keep")

        } else {
            # smoothed data (mean with defined window length)
            signal[i,] = runmean(averageReads, wl, endrule = "keep")
        }     
    }

    # prepare heatmap plot
    if (plotFileName != "") {
        if (grepl(".pdf", plotFileName)) {
            pdf(file = plotFileName, title = plotFileName, width = picDim[1], height = picDim[2], useDingbats = FALSE)  
        } else {
            tiff(filename = plotFileName, width = picDim[1], height = picDim[2], compression = "none", bg = "white", pointsize = 20)
        }
    }

    plot(position, averageReads,  ylim = c(0,1), ylab = "wl", xlab = "fragment position", type = "n", lty = 1, axes = FALSE)

    scale = 1 / (bands + 1.5)
    maxSignal = max(signal)

    # log-scale signal
    signal = log2(signal/maxSignal)

    # set cut-offs for log-scaled data
    capMin = cutoffLog
    capMax = 0.0

    # define axes with custom intervals
    minXAxis = floor(fragsToVisualize$start[1] / xAxisIntervalLength) * xAxisIntervalLength
    maxXAxis = ceiling(fragsToVisualize$end[nrow(fragsToVisualize)] / xAxisIntervalLength) * xAxisIntervalLength
    seqXAxis = seq(minXAxis, maxXAxis, by = xAxisIntervalLength)
    axis(side = 1, at = seqXAxis, labels = seqXAxis, las = 0)

    seqYAxis = c(0.5, bands - 0.5) * scale
    labelsYAxis = c(2*bands-1,1)    

    axis(side = 2, at = seqYAxis, labels = labelsYAxis, las = 2)

    # mark unused fragments (blind / repeated)
    rect(minXAxis, 0, maxXAxis, bands * scale, col = "black", border = NA)

    # prepare color palette 
    colorNumber = capMax*100-capMin*100 + 1
    colors = heat.colors(colorNumber)

    # pick colours for the fragments
    for (i in 1:bands) {

        for (j in 1:nrow(fragsToVisualize)) {

            if (signal[i,j] > capMax) {
                signal[i,j] = capMax
            }
            if (signal[i,j] < capMin) {
                signal[i,j] = capMin
            }

            index = round((signal[i,j] - capMin) * 99) + 1

            pickedColor = colors[index]

            # mark 'missing' fragments at the sides (only fully present running median / mean windows are used)
            if ((j < i) | (j > (nrow(fragsToVisualize) - i))) {
                pickedColor = "black"
            }

            # print fragments in chosen colours
            rect(fragsToVisualize[,2][j], (bands-i+1)*scale, fragsToVisualize[,3][j], (bands-i)*scale, col = pickedColor, border = NA)

        }
    }

    if (plotFileName != "") {
        dev.off()
    }

    # prepare heatmap legend
    chosenPalette = heat.colors(100)

    # prepare color legend plot
    if (plotFileName != "") {
        if (grepl(".pdf", plotFileName)) {
            pdf(file = "color_legend.pdf", title = "Color Legend", width = 2, height = 5, useDingbats=FALSE)  
        } else {
            tiff(filename = "color_legend.tiff", width = 200, height = 500, compression = "none", bg = "white", pointsize = 20)
        }

        par(mar=c(5.1,4.1,4.1,4.1))

        # basic plot
        plot(c(0,10), c(0,1), type='n', main="Signal intensity", axes = FALSE, xlab = "", ylab = "relative window coverage (log-scaled)")

        # add axis...
        legendLength = length(legendLabels) - 1
        axis(2, c((0:legendLength)/legendLength), labels = legendLabels, las = 1)

        # ... and color bands
        for (i in 1:(length(chosenPalette)-1)) {    
            y = (i-1) / 100
            rect(0, y, 10, y+1/100, col = chosenPalette[i], border=NA)
        }

        dev.off()
    }
}




setMethod("drawHeatmap",
    signature=signature(expData="Data4Cseq"),
    .drawHeatmap_Data4Cseq)

setMethod("drawHeatmap",
    signature=signature(expData="data.frame"),
    .drawHeatmap_DataFrame)

setMethod("drawHeatmapMain",
    signature=signature(fragsToVisualize="data.frame"),
    .drawHeatmapMain)

# constructor for class "Data4Cseq"

setMethod("Data4Cseq", signature(viewpointChromosome="character", viewpointInterval="numeric", readLength="numeric", pointsOfInterest="data.frame", rawReads="GAlignments"),
    function(viewpointChromosome, viewpointInterval, readLength, pointsOfInterest, rawReads) {

        for (i in 1:nrow(pointsOfInterest)) {
            if (pointsOfInterest[i,1] != viewpointChromosome) {
                message("One point of interest is not on the viewpoint chromosome and therefore not visible in a near-cis visualization. Alternatively, check for 'chrX / X' notation variety.")
            }        
        }
        pointsOfInterest = subset(pointsOfInterest, pointsOfInterest[,1] == viewpointChromosome)

        if (length(readLength) == 1) {
            if (readLength < 10) {
                message("The specified read length seems to be very short, please check if the number is correct")
            }
            if (readLength > 1000) {
                message("The specified read length seems to be very long, please check if the number is correct")
            }
        }

        if (viewpointInterval[1] > viewpointInterval[2]) {
            temp = viewpointInterval[1]
            viewpointInterval[1] = viewpointInterval[2]
            viewpointInterval[2] = temp
            message("The viewpoint coordinates (a,b) are expected to have the form a < b; switching coordinates...")
        }

        newData4CseqObject = new("Data4Cseq", viewpointChromosome = viewpointChromosome, viewpointInterval = viewpointInterval, readLength = readLength, pointsOfInterest = pointsOfInterest, rawReads = rawReads)

        return(newData4CseqObject)
    }
)


setMethod("Data4Cseq", signature(viewpointChromosome="character", viewpointInterval="numeric", readLength="numeric", pointsOfInterest="missing", rawReads="missing"),
    function(viewpointChromosome, viewpointInterval, readLength, pointsOfInterest, rawReads) {

        if (length(readLength) == 1) {
            if (readLength < 10) {
                message("The specified read length seems to be very short, please check if the number is correct")
            }
            if (readLength > 1000) {
                message("The specified read length seems to be very long, please check if the number is correct")
            }
        }

        if (viewpointInterval[1] > viewpointInterval[2]) {
            temp = viewpointInterval[1]
            viewpointInterval[1] = viewpointInterval[2]
            viewpointInterval[2] = temp
            message("The viewpoint coordinates (a,b) are expected to have the form a < b; switching coordinates...")
        }

        newData4CseqObject = new("Data4Cseq", viewpointChromosome = viewpointChromosome, viewpointInterval = viewpointInterval)

        return(newData4CseqObject)
    }
)


# "set" and "replace" methods for class "Data4Cseq"

setMethod("viewpointChromosome", signature(object="Data4Cseq"),
    function(object) {
        return(object@viewpointChromosome)
    }
)

setReplaceMethod("viewpointChromosome",
    signature=signature(object="Data4Cseq", value="character"),
    function(object, value) {
        object@viewpointChromosome = value
        return(object)
    }
)


setMethod("viewpointInterval", signature(object="Data4Cseq"),
    function(object) {
        return(object@viewpointInterval)
    }
)

setReplaceMethod("viewpointInterval",
    signature=signature(object="Data4Cseq", value="numeric"),
    function(object, value) {
        object@viewpointInterval = value
        return(object)
    }
)


setMethod("readLength", signature(object="Data4Cseq"),
    function(object) {
        return(object@readLength)
    }
)

setReplaceMethod("readLength",
    signature=signature(object="Data4Cseq", value="numeric"),
    function(object, value) {
        object@readLength = value
        return(object)
    }
)


setMethod("pointsOfInterest", signature(object="Data4Cseq"),
    function(object) {
        return(object@pointsOfInterest)
    }
)

setReplaceMethod("pointsOfInterest",
    signature=signature(object="Data4Cseq", value="data.frame"),
    function(object, value) {
        object@pointsOfInterest = value
        return(object)
    }
)


setMethod("rawReads", signature(object="Data4Cseq"),
    function(object) {
        return(object@rawReads)
    }
)

setReplaceMethod("rawReads",
    signature=signature(object="Data4Cseq", value="GAlignments"),
    function(object, value) {
        object@rawReads = value
        return(object)
    }
)


setMethod("rawFragments", signature(object="Data4Cseq"),
    function(object) {
        return(object@rawFragments)
    }
)

setReplaceMethod("rawFragments",
    signature=signature(object="Data4Cseq", value="data.frame"),
    function(object, value) {
        object@rawFragments= value
        return(object)
    }
)

setMethod("nearCisFragments", signature(object="Data4Cseq"),
    function(object) {
        return(object@nearCisFragments)
    }
)

setReplaceMethod("nearCisFragments",
    signature=signature(object="Data4Cseq", value="data.frame"),
    function(object, value) {
        object@nearCisFragments= value
        return(object)
    }
)


setMethod("show", "Data4Cseq",
    function(object){
        cat("4C-seq experiment data\n")
        cat("Type:", class(object), "\n")
        cat("Viewpoint: ", viewpointChromosome(object), ":", viewpointInterval(object)[1], "-", viewpointInterval(object)[2], "\n")
        cat("Read length: ", readLength(object), "\n")
        cat("Number of reads: ", length(rawReads(object)), "\n")
        cat("Number of total fragments: ", nrow(rawFragments(object)), "\n")
        cat("Number of near-cis fragments: ", nrow(nearCisFragments(object)), "\n")
        cat("Points of interest: ", nrow(pointsOfInterest(object)), "\n")
    }
)

.visualizeViewpoint_Data4Cseq <- function(expData, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE) {
    
    fragsToVisualize = formatFragmentData(expData, useFragEnds)
    poi = pointsOfInterest(expData)

    visualizeViewpointMain(fragsToVisualize, poi, plotFileName, windowLength, interpolationType, picDim, maxY, minQuantile, maxQuantile, mainColour, plotTitle, loessSpan, xAxisIntervalLength, yAxisIntervalLength, useFragEnds)
}


.visualizeViewpoint_DataFrame <- function(expData, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE) {
    
    fragsToVisualize = expData
    
    if (!useFragEnds) {
        print("visualizeViewpoint: use of fragment-wise interpolated data not possible for data frame input")
    }

    visualizeViewpointMain(fragsToVisualize, poi, plotFileName, windowLength, interpolationType, picDim, maxY, minQuantile, maxQuantile, mainColour, plotTitle, loessSpan, xAxisIntervalLength, yAxisIntervalLength, useFragEnds)
}


.visualizeViewpointMain <- function(fragsToVisualize, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE) {

    # prepare different color shades  
    colours = c(paste(mainColour, "", sep = ""), paste(mainColour, "2", sep = ""), paste(mainColour, "3", sep = ""))
    
    # prepare data
    yVal = 0
    
    position = round((fragsToVisualize$start + fragsToVisualize$end) / 2)
    averageReads = fragsToVisualize$reads 
    
    if (interpolationType == "median") {
        # smoothed data (median with defined window length)
        yVal = runmed(averageReads, windowLength, endrule = "constant")
    
    } else if (interpolationType == "mean") {
        # smoothed data (mean with defined window length)
        yVal = runmean(averageReads, windowLength, endrule = "constant")
    
    } else {
        # raw data
        yVal = averageReads    
    }
    
    # if no (reasonable) maximum y-value is provided, use the maximum of yValA and yValB, rounded up to the next y-axis marker
    if (maxY == -1) {
        maxY = ceiling(max(yVal) / 500) * 500
    }
    
    # prepare plot
    if (plotFileName != "") {
        if (grepl(".pdf", plotFileName)) {
            pdf(file = plotFileName, title = plotTitle, width = picDim[1], height = picDim[2], useDingbats = FALSE)  
        } else {
            tiff(filename = plotFileName, width = picDim[1], height = picDim[2], compression = "none", bg = "white", pointsize = 20)
        }
    }
    
    # basic plot
    plot(position, yVal,  ylim = c(0,maxY), ylab = "fragment read count (RPM)", xlab = "fragment position", type = "n", main = plotTitle, lty = 1, axes = FALSE)
    
    # plot sample data
    basic4CPlot(position, yVal, averageReads, minQuantile, maxQuantile, windowLength, colours, loessSpan) 
    
    drawMetaData(fragsToVisualize$start[1], fragsToVisualize$end[nrow(fragsToVisualize)], maxY, poi, xAxisIntervalLength, yAxisIntervalLength)   
    
    if (plotFileName != "") {
        dev.off()
    }
    
    # prepare legend plot
    scale = 100
    
    if (plotFileName != "") {
        if (grepl(".pdf", plotFileName)) {
            pdf(file = "quantile_legend.pdf", title = "Main Trend", width = 2, height = 5, useDingbats = FALSE)  
        } else {
            tiff(filename = "quantile_legend.tiff", width = 200, height = 500, compression = "none", bg = "white", pointsize = 20)
        }
    
        # basic plot
        plot(c(0,10), c(0,1), type='n', main="Main trend", axes = FALSE, xlab = '', ylab = "loess-smoothed quantiles")
    
        # add axis...
        axis(2, c(0, 0.5, 1), labels = c(paste(minQuantile, "%", sep = ""), "50%", paste(maxQuantile, "%", sep = "")), las = 1)
    
        # ... quantile representation...
        for (i in 1:100) {    
            y = (i-1) / scale
            rect(0, 0, 10, 1, col = "grey90", border=NA)
        }
    
        # ... and trend line
        lines(c(0, 10), c(0.5, 0.5), col = "black", lwd = 3)

        dev.off()
    }
}


.basic4CPlot <- function(position, yVal, averageReads, minQuantile, maxQuantile, windowLength, colours, loessSpan = 0.1) {

    # calculate quantiles and smooth the curve with R's loess function
    quanMin = runquantile(averageReads, windowLength, probs = minQuantile)
    yMin <- loess(quanMin ~ position, span=loessSpan, data.frame(position = position, quanMin = quanMin))
    yMinPredict <- predict(yMin, data.frame(position = position))
    
    quanMax = runquantile(averageReads, windowLength, probs = maxQuantile)
    yMax <- loess(quanMax ~ position, span=loessSpan, data.frame(position = position, quanMax = quanMax))
    yMaxPredict <- predict(yMax, data.frame(position = position))

    # visualize quantiles as polygon (light-grey)
    polygon(c(position, rev(position)), c(yMinPredict, rev(yMaxPredict)), col = "grey90", border = NA)
    
    # plot interpolated data points (median or mean)
    lines(position, yVal, type="p", col= colours[1], lwd = 0.2, lty = 1, pch = 20, cex = 0.5)
    
    # smooth main trend (loess)
    yLoess <- loess(yVal ~ position, span = loessSpan, data.frame(position = position, yVal = yVal))
    yPredict <- predict(yLoess, data.frame(position = position))
    lines(position, yPredict, col = colours[3], lwd = 1)

    # raw data points (fragment-based)
    points(position, averageReads, col = "grey40", pch = ".")  
}


.drawMetaData <- function(minX, maxX, maxY, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), xAxisIntervalLength = 50000, yAxisIntervalLength = 500) {
    
    # if present, print points of interest as defined by the user
    if (nrow(poi) > 0) {
        pointsX = c(poi$start, poi$end)
        pointsY = round(maxY * 0.97)

        points(round((poi$start + poi$end) / 2), rep(round(maxY * 0.95), times = nrow(poi)), cex = 1.0, pch = 25, col = as.vector(poi$colour), bg = as.vector(poi$colour))
        text(round((poi$start + poi$end) / 2), round(maxY * 0.99), poi$name, cex = 1.0)
    }

    # print axes with custom intervals
    minXAxis = floor(minX / xAxisIntervalLength) * xAxisIntervalLength
    maxXAxis = ceiling(maxX / xAxisIntervalLength) * xAxisIntervalLength
    seqXAxis = seq(minXAxis, maxXAxis, by = xAxisIntervalLength)
    axis(side = 1, at = seqXAxis, labels = seqXAxis, las = 0)
    
    seqYAxis = seq(0, ceiling(maxY / yAxisIntervalLength) * yAxisIntervalLength, by = yAxisIntervalLength)
    axis(side = 2, at = seqYAxis, labels = seqYAxis, las = 2)  
}




setMethod("visualizeViewpoint",
    signature=signature(expData="Data4Cseq"),
    .visualizeViewpoint_Data4Cseq)

setMethod("visualizeViewpoint",
    signature=signature(expData="data.frame"),
    .visualizeViewpoint_DataFrame)

setMethod("visualizeViewpointMain",
    signature=signature(fragsToVisualize="data.frame"),
    .visualizeViewpointMain)


setMethod("basic4CPlot",
    signature=signature(position="numeric", yVal="numeric", averageReads="numeric", minQuantile="numeric", maxQuantile="numeric", windowLength="numeric", colours="character"),
    .basic4CPlot)


setMethod("drawMetaData",
    signature=signature(minX="numeric", maxX="numeric", maxY="numeric"),
    .drawMetaData)

.printWigFile <- function(expData, wigFileName = "output.wig", fixedSpan = TRUE, headerUCSC = "", useOnlyIndex = FALSE) {
    
    fragmentData = rawFragments(expData)
    chromosomes = unique(as.vector(fragmentData$chromosomeName))

    # prepare chromosome names for wig --> even if "1"..."Y" have been used for the library or in the reference genome, 
    # one may wish to print the wig with "chr1"..."chrY" notations
    chromosomeNamesWig = gsub("chr", "", as.character(chromosomes))
    if (!useOnlyIndex) {
        chromosomeNamesWig = paste("chr", chromosomeNamesWig, sep = "")
    }

    wigFileContent = NULL

    if (headerUCSC != "") {
        wigFileContent = headerUCSC
    }
    
    for (i in 1:length(chromosomes)) {

        fragsChromosome = subset(fragmentData, fragmentData$chromosomeName == chromosomes[i])
        chromosomeWig = giveWigDataChromosome(fragsChromosome, readLength(expData), chromosomeNamesWig[i], fixedSpan)

        wigFileContent = c(wigFileContent, chromosomeWig)
    }
    
    fileConn <- file(wigFileName)

    writeLines(wigFileContent, fileConn)

    close(fileConn)
}


.giveWigDataChromosome <- function(fragmentDataChromosome, readLength, chromosomeID, fixedSpan = TRUE) {

    if (!fixedSpan) {
        # variable step
        wigHeader = paste("variableStep chrom=", chromosomeID, sep = "")
    } else {
        # variable step with fixed span (read length)
        wigHeader = paste("variableStep chrom=", chromosomeID, " span=", readLength, sep = "")
    }

    # get reads on valid unique fragments
    fragmentDataLeftValid = subset(fragmentDataChromosome, fragmentDataChromosome$leftFragEndValid == TRUE)
    fragmentDataRightValid = subset(fragmentDataChromosome, fragmentDataChromosome$rightFragEndValid == TRUE)

    fragsLeft = cbind(fragmentDataLeftValid$fragmentStart, fragmentDataLeftValid$leftFragEndReads)
    fragsRight = cbind(fragmentDataRightValid$fragmentEnd - readLength + 1, fragmentDataRightValid$rightFragEndReads)

    if (!fixedSpan) {
        fragsLeftPos = NULL
        fragsLeftReads = NULL
        fragsRightPos = NULL
        fragsRightReads = NULL
        for (i in 1:readLength) {
            fragsLeftPos = c(fragsLeftPos, fragsLeft[,1]+i-1)
            fragsLeftReads = c(fragsLeftReads, fragsLeft[,2])
            fragsRightPos = c(fragsRightPos, fragsRight[,1]+i-1)
            fragsRightReads = c(fragsRightReads, fragsRight[,2])
        }
        fragsLeft = cbind(fragsLeftPos, fragsLeftReads)
        fragsRight = cbind(fragsRightPos, fragsRightReads)
    }

    fragEnds = rbind(fragsLeft, fragsRight)
    fragEnds = fragEnds[order(fragEnds[,1]),]

    wigData = c(wigHeader, paste(fragEnds[,1], fragEnds[,2], sep = " "))

    return(wigData)
}




setMethod("printWigFile",
    signature=signature(expData="Data4Cseq"),
    .printWigFile)


setMethod("giveWigDataChromosome",
    signature=signature(fragmentDataChromosome="data.frame", readLength="numeric", chromosomeID="character"),
    .giveWigDataChromosome)

.readPointsOfInterestFile <- function(poiFile) {
    
    if (poiFile != "") {
        poiTable = read.table(poiFile, sep = "\t", header = FALSE)
        colnames(poiTable) = c("chr", "start", "end", "name", "colour")

        chrNames = unique(poiTable$chr)
        if (length(chrNames) > 1) {
            message("Please provide only points of interest on the viewpoint chromosome for the near-cis visualizations")
        }
    } else {
        poiTable = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character())
    }

    return(poiTable)
}


.exportVisualizationFragmentData <- function(expData, fileName, fullData = FALSE) {
    
    if (fullData) {
        fragmentData = nearCisFragments(expData)    
    } else {
        fragmentData = formatFragmentData(expData)
    } 
    write.table(fragmentData, file = fileName, sep = "\t", quote = FALSE, row.names = FALSE, col.names = TRUE)
}


.importVisualizationFragmentData <- function(fileName) {

    fragmentData = read.table(file = fileName, header = TRUE)
    return(fragmentData)
}




setMethod("readPointsOfInterestFile",
    signature=signature(poiFile="character"),
    .readPointsOfInterestFile)


setMethod("exportVisualizationFragmentData",
    signature=signature(expData="Data4Cseq", fileName="character"),
    .exportVisualizationFragmentData)


setMethod("importVisualizationFragmentData",
    signature=signature(fileName="character"),
    .importVisualizationFragmentData)

.formatFragmentData_Data4Cseq <- function(expData, useFragEnds = TRUE) {

    normalizedFragData = nearCisFragments(expData)

    formatFragmentDataMain(normalizedFragData, useFragEnds)
}


.formatFragmentData_DataFrame <- function(expData, useFragEnds = TRUE) {

    normalizedFragData = expData

    formatFragmentDataMain(normalizedFragData, useFragEnds)
}


.formatFragmentDataMain <- function(normalizedFragData, useFragEnds = TRUE) {

    if (useFragEnds) {
        fragmentDataLeftUnique = subset(normalizedFragData, normalizedFragData$leftFragEndValid == TRUE)
        fragmentDataRightUnique = subset(normalizedFragData, normalizedFragData$rightFragEndValid == TRUE)

        fragsLeft = fragmentDataLeftUnique[,c(1,2,4,11)]
        fragsRight = fragmentDataRightUnique[,c(1,4,3,12)]
        fragsRight[,2] = fragsRight[,2] + 1

        colnames(fragsLeft) = c("chrom", "start", "end", "reads")
        colnames(fragsRight) = c("chrom", "start", "end", "reads")

        fragEnds = rbind(fragsLeft, fragsRight)
        fragmentDataFinal = fragEnds[order(fragEnds[,1], fragEnds[,2]),]

    } else {
        fragments = subset(normalizedFragData, normalizedFragData$leftFragEndValid == TRUE & normalizedFragData$rightFragEndValid == TRUE)

        fragmentDataFinal = fragments[,c(1:3,13)]
        colnames(fragmentDataFinal) = c("chrom", "start", "end", "reads")
    }

    row.names(fragmentDataFinal) = NULL

    return(fragmentDataFinal)
}




setMethod("formatFragmentData",
    signature=signature(expData="Data4Cseq"),
    .formatFragmentData_Data4Cseq)

setMethod("formatFragmentData",
    signature=signature(expData="data.frame"),
    .formatFragmentData_DataFrame)

setMethod("formatFragmentDataMain",
    signature=signature(normalizedFragData="data.frame"),
    .formatFragmentDataMain)

setClass("Data4Cseq",
    representation=list( 
        viewpointChromosome="character",
        viewpointInterval="numeric",
        readLength="numeric",
        pointsOfInterest="data.frame",
        rawReads="GAlignments",
        rawFragments="data.frame",
        nearCisFragments="data.frame"
    ),

    prototype=prototype(
        viewpointChromosome="chr1",
        viewpointInterval=c(1,2),
        readLength=30,
        pointsOfInterest=data.frame(),
        rawReads=GAlignments(),
        rawFragments=data.frame(),
        nearCisFragments=data.frame()
    ),

    validity=function(object) {
        if (length(readLength(object)) != 1)
            return("Read length has to be a single number")
        if (length(viewpointInterval(object)) != 2)
            return("The viewpoint interval should consist of a start and end coordinate of the form c(A, B)")
        return(TRUE)
    }
)

.plotTransInteractions_Character <- function(interactionFile, chromosomeViewpoint, coordViewpoint, ideogramData, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8)) {

    interactionData = read.table(interactionFile)
    cyto.info = read.table(ideogramData, header = TRUE)

    plotTransInteractionsMain(interactionData, chromosomeViewpoint, coordViewpoint, cyto.info, PlotColor, expandBands, expansionValue, plotFileName, picDim)
}


.plotTransInteractions_DataFrame <- function(interactionFile, chromosomeViewpoint, coordViewpoint, ideogramData, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8)) {

    interactionData = interactionFile
    cyto.info = ideogramData

    plotTransInteractionsMain(interactionData, chromosomeViewpoint, coordViewpoint, cyto.info, PlotColor, expandBands, expansionValue, plotFileName, picDim)
}


.plotTransInteractionsMain <- function(interactionData, chromosomeViewpoint, coordViewpoint, cyto.info, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8)) {

    chromA = chromosomeViewpoint
    chromStartA = coordViewpoint[1]
    chromEndA = coordViewpoint[2]
    chromB = as.vector(interactionData[,1])
    chromStartB = interactionData[,2]
    chromEndB = interactionData[,3]

    if (expandBands) {
        chromStartA = max(0, chromStartA - expansionValue)
        chromEndA = chromEndA + expansionValue
        for (i in 1:length(chromB)) {
            chromStartB[i] = max(0, chromStartB[i] - expansionValue)
            chromEndB[i] = chromEndB[i] + expansionValue
        }
    }

    if (PlotColor != "default") {
        circosData = data.frame(chromA, chromStartA, chromEndA, chromB, chromStartB, chromEndB, PlotColor)
    } else {
        circosData = data.frame(chromA, chromStartA, chromEndA, chromB, chromStartB, chromEndB)
    }
    chr.exclude = NULL

    tracks.inside = 1
    tracks.outside = 0
    RCircos.Set.Core.Components(cyto.info, chr.exclude, tracks.inside, tracks.outside)

    if (plotFileName != "") {
        if (grepl(".pdf", plotFileName)) {
            pdf(file = plotFileName, title = plotFileName, width = picDim[1], height = picDim[2], useDingbats = FALSE)  
        } else {
            tiff(filename = plotFileName, width = picDim[1], height = picDim[2], compression = "none", bg = "white", pointsize = 20)
        }
    }

    RCircos.Set.Plot.Area()

    plot.window(c(-1.5,1.5), c(-1.5,1.5))

    RCircos.Chromosome.Ideogram.Plot()

    RCircos.Ribbon.Plot(ribbon.data=circosData, track.num=1, by.chromosome=FALSE, twist=FALSE)

    if (plotFileName != "") {
        dev.off()
    }
}




setMethod("plotTransInteractions",
    signature=signature(interactionFile="character", chromosomeViewpoint="character", coordViewpoint="numeric", ideogramData="character"),
    .plotTransInteractions_Character)

setMethod("plotTransInteractions",
    signature=signature(interactionFile="data.frame", chromosomeViewpoint="character", coordViewpoint="numeric", ideogramData="data.frame"),
    .plotTransInteractions_DataFrame)

setMethod("plotTransInteractionsMain",
    signature=signature(interactionData="data.frame", chromosomeViewpoint="character", coordViewpoint="numeric", cyto.info="data.frame"),
    .plotTransInteractionsMain)

.giveEnzymeSequence <- function(fileNameDatabase, enzymeName) {

    enzymeDB = read.table(fileNameDatabase, header = TRUE)
    chosenEnzyme = subset(enzymeDB, enzymeDB$name == enzymeName)
    enzymeSequence = as.character(chosenEnzyme[1,2])  

    return(enzymeSequence)  
}




setMethod("giveEnzymeSequence",
    signature=signature(fileNameDatabase="character", enzymeName="character"),
    .giveEnzymeSequence)

.prepare4CseqData <- function(fastqFileName, firstCutter, fragmentLibrary, referenceGenome, pathToBWA = "", pathToSam = "", pathToBED = "", controlCutterSequence = FALSE, bwaThreads = 1, minFragEndLength = 0) {

    tempAnalysisID = unlist(strsplit(fastqFileName, "/"))
    analysisID = sub(".fastq", "", tempAnalysisID[length(tempAnalysisID)])

    # align the raw 4C-seq reads with BWA
    system(paste(pathToBWA, "bwa aln -n 2 -t ", bwaThreads, " ", referenceGenome, " ", fastqFileName, " > ", analysisID, ".sai", sep = ""))
    system(paste(pathToBWA, "bwa samse ", referenceGenome, " ", analysisID, ".sai ", fastqFileName, " > ", analysisID, "_raw.sam", sep = ""))

    system(paste("rm ", analysisID, ".sai", sep = ""))

    if (controlCutterSequence) {
        # filter: check cutter sequence for mismatches
        checkRestrictionEnzymeSequence(firstCutter, paste(analysisID, "_raw.sam", sep = ""), paste(analysisID, "_filtered.sam", sep = ""))
        longAnalysisID = paste(analysisID, "_filtered", sep = "")
        #system(paste("rm ", analysisID, "_raw.sam", sep = ""))
    } else {
        longAnalysisID = paste(analysisID, "_raw", sep = "")
    }

    # prepare sorted bam-file and index for possible IGV visualization 
    system(paste(pathToSam, "samtools view -b -S ", longAnalysisID, ".sam > ", longAnalysisID, ".bam", sep = ""))
    system(paste(pathToSam, "samtools sort ", longAnalysisID, ".bam ", longAnalysisID, sep = ""))
    system(paste(pathToSam, "samtools index ", longAnalysisID, ".bam", sep = ""))

    # extract relevant rows from [virtual] fragment library for intersectBed
    printBEDFragmentLibrary(fragmentLibrary, "fragmentLibBED.bed", minFragEndLength = minFragEndLength, zeroBased = FALSE)

    # intersect filtered 4C-seq reads with fragment library
    system(paste(pathToBED, "intersectBed -abam ", longAnalysisID, ".bam -b fragmentLibBED.bed > ", analysisID, "_4Cseq.bam", sep = ""))

    # remove bed file (full information stored in fragment library)
    system("rm fragmentLibBED.bed")

    # sort and index remaining 4C-seq reads for possible IGV visualization
    system(paste(pathToSam, "samtools sort ", analysisID, "_4Cseq.bam ", analysisID, "_4Cseq", sep = ""))
    system(paste(pathToSam, "samtools index ", analysisID, "_4Cseq.bam", sep = ""))
}




setMethod("prepare4CseqData",
    signature=signature(fastqFileName="character", firstCutter="character", fragmentLibrary="character", referenceGenome="character"),
    .prepare4CseqData)

# generics for data preprocessing
setGeneric("prepare4CseqData", signature=c("fastqFileName", "firstCutter", "fragmentLibrary", "referenceGenome"),
    function(fastqFileName, firstCutter, fragmentLibrary, referenceGenome, pathToBWA = "", pathToSam = "", pathToBED = "", controlCutterSequence = FALSE, bwaThreads = 1, minFragEndLength = 0)
        standardGeneric("prepare4CseqData"))


# generics for quality controls
setGeneric("getReadDistribution", signature=c("expData"),
    function(expData, distanceFromVP = 100000, useFragEnds = TRUE, outputName = "")
        standardGeneric("getReadDistribution"))


# generics for export / import functions
setGeneric("printBEDFragmentLibrary", signature=c("fragmentLibrary", "BEDLibraryName"),
    function(fragmentLibrary, BEDLibraryName, minFragEndLength = 0, zeroBased = FALSE)
        standardGeneric("printBEDFragmentLibrary"))

setGeneric("printWigFile", signature=c("expData"),
    function(expData, wigFileName = "output.wig", fixedSpan = TRUE, headerUCSC = "", useOnlyIndex = FALSE)
        standardGeneric("printWigFile"))

setGeneric("giveWigDataChromosome", signature=c("fragmentDataChromosome", "readLength", "chromosomeID"),
    function(fragmentDataChromosome, readLength, chromosomeID, fixedSpan = TRUE)
        standardGeneric("giveWigDataChromosome"))

setGeneric("readPointsOfInterestFile", signature=c("poiFile"),
    function(poiFile)
        standardGeneric("readPointsOfInterestFile"))

setGeneric("exportVisualizationFragmentData", signature=c("expData", "fileName"),
    function(expData, fileName, fullData = FALSE)
        standardGeneric("exportVisualizationFragmentData"))

setGeneric("importVisualizationFragmentData", signature=c("fileName"),
    function(fileName)
        standardGeneric("importVisualizationFragmentData"))


# generics for 4C-seq fragment analysis and helper functions
setGeneric("readsToFragments", signature=c("expData", "fragmentLib"),
    function(expData, fragmentLib)
        standardGeneric("readsToFragments"))

setGeneric("chooseNearCisFragments", signature=c("expData", "regionCoordinates"),
    function(expData, regionCoordinates, deleteViewpoint = TRUE)
        standardGeneric("chooseNearCisFragments"))

setGeneric("normalizeFragmentData", signature=c("expData"),
    function(expData)
        standardGeneric("normalizeFragmentData"))

setGeneric("formatFragmentData", signature=c("expData"),
    function(expData, useFragEnds = TRUE)
        standardGeneric("formatFragmentData"))

setGeneric("formatFragmentDataMain", signature=c("normalizedFragData"),
    function(normalizedFragData, useFragEnds = TRUE)
        standardGeneric("formatFragmentDataMain"))

setGeneric("giveEnzymeSequence", signature=c("fileNameDatabase", "enzymeName"),
    function(fileNameDatabase, enzymeName)
        standardGeneric("giveEnzymeSequence"))


# generics for 4C-seq visualization
setGeneric("visualizeViewpoint", signature=c("expData"),
    function(expData, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE)
        standardGeneric("visualizeViewpoint"))

setGeneric("visualizeViewpointMain", signature=c("fragsToVisualize"),
    function(fragsToVisualize, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE)
        standardGeneric("visualizeViewpointMain"))

setGeneric("basic4CPlot", signature=c("position", "yVal", "averageReads", "minQuantile", "maxQuantile", "windowLength", "colours"),
    function(position, yVal, averageReads, minQuantile, maxQuantile, windowLength, colours, loessSpan = 0.1)
        standardGeneric("basic4CPlot"))

setGeneric("drawMetaData", signature=c("minX", "maxX", "maxY"),
    function(minX, maxX, maxY, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), xAxisIntervalLength = 50000, yAxisIntervalLength = 500)
        standardGeneric("drawMetaData"))

setGeneric("drawHeatmap", signature=c("expData"),
    function(expData, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE)
        standardGeneric("drawHeatmap"))

setGeneric("drawHeatmapMain", signature=c("fragsToVisualize"),
    function(fragsToVisualize, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE)
        standardGeneric("drawHeatmapMain"))

setGeneric("plotTransInteractions",
    function(interactionFile, chromosomeViewpoint, coordViewpoint, ideogramData, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8))
        standardGeneric("plotTransInteractions"))

setGeneric("plotTransInteractionsMain",
    function(interactionData, chromosomeViewpoint, coordViewpoint, cyto.info, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8))
        standardGeneric("plotTransInteractionsMain"))


# generics for first cutter check
setGeneric("checkRestrictionEnzymeSequence", signature=c("firstCutter", "inputFileName"),
    function(firstCutter, inputFileName, outputFileName = "output.sam", keepOnlyUniqueReads = TRUE, writeStatistics = TRUE)
        standardGeneric("checkRestrictionEnzymeSequence"))


# generics for fragment library creation
setGeneric("createVirtualFragmentLibrary", signature=c("chosenGenome", "firstCutter", "secondCutter", "readLength"),
    function(chosenGenome, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, useAllData = TRUE, chromosomeName = "chr1", libraryName = "default")
        standardGeneric("createVirtualFragmentLibrary"))

setGeneric("splitChromosome", signature=c("firstCutter", "secondCutter", "chromosomeToSplit", "chromosomeName"),
    function(firstCutter, secondCutter, chromosomeToSplit, chromosomeName, onlyNonBlind = TRUE)
        standardGeneric("splitChromosome"))

setGeneric("createVirtualFragmentLibraryMain", signature=c("totalFragments", "totalFragmentsRev", "firstCutter", "secondCutter", "readLength"),
    function(totalFragments, totalFragmentsRev, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, chromosomeName = "chr1", libraryName = "default")
        standardGeneric("createVirtualFragmentLibraryMain"))


# generics for in silico digestion ("real" fragment library control -> expected fragment sizes)
setGeneric("simulateDigestion", signature=c("firstCutter", "secondCutter", "dnaSequence"),
    function(firstCutter, secondCutter, dnaSequence)
        standardGeneric("simulateDigestion"))

setGeneric("simulateDigestionChromosome", signature=c("firstCutter", "secondCutter", "dnaSequence"),
    function(firstCutter, secondCutter, dnaSequence)
        standardGeneric("simulateDigestionChromosome"))

setGeneric("drawDigestionFragmentHistogram", signature=c("fragments"),
    function(fragments, minLength = 0, maxLength = 10000)
        standardGeneric("drawDigestionFragmentHistogram"))


# class generics
setGeneric("Data4Cseq", function(viewpointChromosome, viewpointInterval, readLength, pointsOfInterest, rawReads) {
    standardGeneric("Data4Cseq")})

setGeneric("viewpointChromosome", function(object) {
    standardGeneric("viewpointChromosome")})

setGeneric("viewpointChromosome<-", function(object, value) {
    standardGeneric("viewpointChromosome<-")})

setGeneric("viewpointInterval", function(object) {
    standardGeneric("viewpointInterval")})

setGeneric("viewpointInterval<-", function(object, value) {
    standardGeneric("viewpointInterval<-")})

setGeneric("readLength", function(object) {
    standardGeneric("readLength")})

setGeneric("readLength<-", function(object, value) {
    standardGeneric("readLength<-")})

setGeneric("pointsOfInterest", function(object) {
    standardGeneric("pointsOfInterest")})

setGeneric("pointsOfInterest<-", function(object, value) {
    standardGeneric("pointsOfInterest<-")})

setGeneric("rawReads", function(object) {
    standardGeneric("rawReads")})

setGeneric("rawReads<-", function(object, value) {
    standardGeneric("rawReads<-")})

setGeneric("rawFragments", function(object) {
    standardGeneric("rawFragments")})

setGeneric("rawFragments<-", function(object, value) {
    standardGeneric("rawFragments<-")})

setGeneric("nearCisFragments", function(object) {
    standardGeneric("nearCisFragments")})

setGeneric("nearCisFragments<-", function(object, value) {
    standardGeneric("nearCisFragments<-")})

.normalizeFragmentData <- function(expData) {

    readCount = length(rawReads(expData))
    relevantFragData = nearCisFragments(expData)

    # simple RPM normalization (reads per million)
    RPMFrags <- relevantFragData
    RPMFrags$leftFragEndReads <- RPMFrags$leftFragEndReads / readCount * 1000000
    RPMFrags$rightFragEndReads <- RPMFrags$rightFragEndReads / readCount * 1000000
    RPMFrags$fragEndReadsAverage <- RPMFrags$fragEndReadsAverage / readCount * 1000000

    return(RPMFrags)
}




setMethod("normalizeFragmentData",
    signature=signature(expData="Data4Cseq"),
    .normalizeFragmentData)

.createVirtualFragmentLibrary_BSgenome <- function(chosenGenome, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, useAllData = TRUE, chromosomeName = "chr1", libraryName = "default") {

    chromosomeNames = seqnames(chosenGenome)
    
    totalFragments = NULL
    totalFragmentsRev = NULL

    # for each chromosome: split current chromosome at the first cutter sequence
    # and check for presence of the second cutter within the resulting fragments
    # --> remove non-unique and blind fragments (if chosen; default == TRUE) for final output
    for (i in 1:length(chromosomeNames)) {

        chromosomeToSplit = chosenGenome[[i]]

        if (class(chromosomeToSplit) == "MaskedDNAString") {
            chromosomeToSplit = unmasked(chromosomeToSplit)
        }

        if (useAllData) {
            message(paste("analyzing ", chromosomeNames[i], "...", sep = ""))
            chromosomeToSplitRev = reverseComplement(chromosomeToSplit)
            currentChromosome = splitChromosome(firstCutter, secondCutter, chromosomeToSplit, chromosomeNames[i])
            currentChromosomeRev = splitChromosome(firstCutter, secondCutter, chromosomeToSplitRev, chromosomeNames[i])
            totalFragments = rbind(totalFragments, currentChromosome)
            totalFragmentsRev = rbind(currentChromosomeRev, totalFragmentsRev)
        } else {

            if (length(chromosomeToSplit) > 20000000) {
                message(paste("analyzing ", chromosomeNames[i], "...", sep = ""))
                chromosomeToSplitRev = reverseComplement(chromosomeToSplit)
                currentChromosome = splitChromosome(firstCutter, secondCutter, chromosomeToSplit, chromosomeNames[i])
                currentChromosomeRev = splitChromosome(firstCutter, secondCutter, chromosomeToSplitRev, chromosomeNames[i])
                totalFragments = rbind(totalFragments, currentChromosome)
                totalFragmentsRev = rbind(currentChromosomeRev, totalFragmentsRev)
            } else {
                message(paste("skipping ", chromosomeNames[i], " due to its length", sep = ""))
            }
        }
    }

    if (!(is.null(totalFragments))) {
        createVirtualFragmentLibraryMain(totalFragments, totalFragmentsRev, firstCutter, secondCutter, readLength, onlyNonBlind, useOnlyIndex, minSize, maxSize, minFragEndSize, maxFragEndSize, chromosomeName, libraryName)
    } else {
        message("No fragments created; please use 'useAllData = TRUE' for genomes with small chromosomes")
    }
}


.createVirtualFragmentLibrary_DNAString <- function(chosenGenome, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, useAllData = TRUE, chromosomeName = "chr1", libraryName = "default") {

    totalFragments = NULL
    totalFragmentsRev = NULL

    # only one chromosome present: split current chromosome at the first cutter sequence
    # and check for presence of the second cutter within the resulting fragments
    # --> remove non-unique and blind fragments (if chosen; default == TRUE) for final output
    if (useAllData) {
        chromosomeToSplit = chosenGenome
        chromosomeToSplitRev = reverseComplement(chosenGenome)
        totalFragments = splitChromosome(firstCutter, secondCutter, chromosomeToSplit, chromosomeName)
        totalFragmentsRev = splitChromosome(firstCutter, secondCutter, chromosomeToSplitRev, chromosomeName)
        createVirtualFragmentLibraryMain(totalFragments, totalFragmentsRev, firstCutter, secondCutter, readLength, onlyNonBlind, useOnlyIndex, minSize, maxSize, minFragEndSize, maxFragEndSize, chromosomeName, libraryName)
    } else {
        chromosomeToSplit = chosenGenome

        if (length(chromosomeToSplit) > 20000000) {      
            chromosomeToSplitRev = reverseComplement(chosenGenome)
            totalFragments = splitChromosome(firstCutter, secondCutter, chromosomeToSplit, chromosomeName)
            totalFragmentsRev = splitChromosome(firstCutter, secondCutter, chromosomeToSplitRev, chromosomeName)
            createVirtualFragmentLibraryMain(totalFragments, totalFragmentsRev, firstCutter, secondCutter, readLength, onlyNonBlind, useOnlyIndex, minSize, maxSize, minFragEndSize, maxFragEndSize, chromosomeName, libraryName)
        } else {
            message("Chromosome's length is below threshold; use 'useAllData = TRUE' (default) to create a virtual fragment library for any chromosome length")
        }
    }
}


.splitChromosome_DNAString <- function(firstCutter, secondCutter, chromosomeToSplit, chromosomeName) {

    # first step: get position of the cutter sequences and calculate start and end of fragment in between
    #  --> cutter sequence neglected for fragment to provide disjunct fragment intervals
    rawFragments = matchPattern(firstCutter, chromosomeToSplit)
    fragmentStart = c(1, end(rawFragments) + 1)
    fragmentEnd = c(start(rawFragments) - 1, length(chromosomeToSplit))

    # second step: read chromosome as string and check which fragments are blind (no second cutter present
    # or non-blind (second cutter sequence present within fragment sequence)
    chromosomeTotal = toString(chromosomeToSplit)
    fragmentSequences = unlist(strsplit(chromosomeTotal, split=toupper(firstCutter)))
    secondCutterPresent = grepl(toupper(secondCutter), fragmentSequences)

    # sequences at start and end of chromosome not counted as non-blind fragments 
    # --> valid non-blind fragments: only [FCE ... SCE ... FCE], not [1 ... (SCE) ... FCE] or [FCE ... (SCE) ... END] 
    secondCutterPresent[1] = FALSE
    secondCutterPresent[length(secondCutterPresent)] = FALSE

    emptyLastFrag = FALSE

    if (length(fragmentEnd) > length(secondCutterPresent)) {
        secondCutterPresent = c(secondCutterPresent, FALSE)
        fragmentSequences = c(fragmentSequences, "")
        emptyLastFrag = TRUE
    }

    # fragments total
    fragmentTable = data.frame(chromosomeName, fragmentStart, fragmentEnd, secondCutterPresent, fragmentSequences)
    fragmentTable[,5] = as.vector(fragmentTable[,5])

    # delete possible empty fragment if cutter sequence is at the end of the genome
    if (emptyLastFrag) {
        fragmentTable = fragmentTable[-nrow(fragmentTable),]
    }

    secondCutterPos = gregexpr(toupper(secondCutter), fragmentTable[,5])
    secondCutterFirst = NULL
    secondCutterLast = NULL

    for (i in 1:length(secondCutterPos)) {
        secondCutterFirst[i] = secondCutterPos[[i]][1]
        secondCutterLast[i] = secondCutterPos[[i]][length(secondCutterPos[[i]])]
    }

    fragmentTable["secondCutterFirst"] = secondCutterFirst
    fragmentTable["secondCutterLast"] = secondCutterLast

    # return bed-like format: chromosome name, fragment start, fragment end plus fragment sequence and second cutter positions
    return(fragmentTable)
}


.createVirtualFragmentLibraryMain <- function(totalFragments, totalFragmentsRev, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, chromosomeName = "chr1", libraryName = "default") {

    # if necessary, change chromosome name from "chr1"..."chrY" to "1"..."Y"
    if (useOnlyIndex) {
        totalFragments$chromosomeName = sub("chr", "", totalFragments$chromosomeName)
        totalFragmentsRev$chromosomeName = sub("chr", "", totalFragmentsRev$chromosomeName)
    }

    totalFragments["fragmentLength"] = nchar(totalFragments$fragmentSequences)
    totalFragmentsRev["fragmentLength"] = nchar(totalFragmentsRev$fragmentSequences)

    # calculate frag end lengths
    leftFragEndLength = ifelse(totalFragments$secondCutterFirst == -1, totalFragments$fragmentLength, totalFragments$secondCutterFirst - 1)
    rightFragEndLength = ifelse(totalFragments$secondCutterFirst == -1, totalFragments$fragmentLength, totalFragments$fragmentLength - totalFragments$secondCutterLast + 1 - nchar(secondCutter))
    leftFragEndLengthRev = ifelse(totalFragmentsRev$secondCutterFirst == -1, totalFragmentsRev$fragmentLength, totalFragmentsRev$secondCutterFirst - 1)
    rightFragEndLengthRev = ifelse(totalFragmentsRev$secondCutterFirst == -1, totalFragmentsRev$fragmentLength, totalFragmentsRev$fragmentLength - totalFragmentsRev$secondCutterLast + 1 - nchar(secondCutter))

    # valid 4C-seq reads map to one of the experiment's fragment ends and continue with the downstream sequence
    fragSeqStart = substr(totalFragments$fragmentSequences, start = 1, stop = readLength)
    fragSeqStartRev = substr(totalFragmentsRev$fragmentSequences, start = 1, stop = readLength)

    # check fragment ends for uniqueness
    uniqueFromStart = !duplicated(c(fragSeqStart, fragSeqStartRev))
    uniqueFromEnd = !duplicated(c(fragSeqStart, fragSeqStartRev), fromLast = TRUE)
    uniqueSeq = uniqueFromStart & uniqueFromEnd

    uniqueFragStart = uniqueSeq[1:nrow(totalFragments)]
    uniqueFragEnd = rev(uniqueSeq[(nrow(totalFragments)+1):(nrow(totalFragments)*2)])

    rm(totalFragmentsRev)

    # remove raw sequences
    totalFragments = totalFragments[,-5]

    # mark fragments with length < readLength as not usable, check minimum and maximum fragment end sizes
    minFragEndSize = max(readLength, minFragEndSize)
    leftLongEnough = ifelse((leftFragEndLength >= minFragEndSize & leftFragEndLength <= maxFragEndSize), TRUE, FALSE)
    rightLongEnough = ifelse((rightFragEndLength >= minFragEndSize & rightFragEndLength <= maxFragEndSize), TRUE, FALSE)

    leftFragEndValid = uniqueFragStart & leftLongEnough
    rightFragEndValid = uniqueFragEnd & rightLongEnough

    # centre of fragment: middle between first and last second cutter site, if second cutter present
    fragmentCentre = ifelse(totalFragments$secondCutterFirst == -1, round((totalFragments$fragmentStart + totalFragments$fragmentEnd) / 2), round((totalFragments$secondCutterFirst + totalFragments$secondCutterLast) / 2) + totalFragments$fragmentStart + 1)

    isNonBlind = totalFragments$secondCutterPresent

    fragData = data.frame(totalFragments[,1:3], fragmentCentre, isNonBlind, "fragmentLength" = totalFragments$fragmentLength, leftFragEndLength, rightFragEndLength, leftFragEndValid, rightFragEndValid)

    if (onlyNonBlind) {
        fragData = subset(fragData, fragData$isNonBlind == TRUE)
    }

    # if chosen, keep only fragments with a fragment length of more than X bp...
    fragData = subset(fragData, fragData$fragmentLength >= minSize)
    # ... and less than Y bp
    if (maxSize != -1) {
        fragData = subset(fragData, fragData$fragmentLength <= maxSize)
    }

    # output: fragment coordinates and flags for uniqueness
    if (libraryName == "default") {
        if (onlyNonBlind) {
            libraryName = paste("fragments_", firstCutter, "_", secondCutter, ".csv", sep = "")
        } else {
            libraryName = paste("fragments_", firstCutter, "_", secondCutter, "_with_blind_fragments", ".csv", sep = "")
        }
    }

    if (libraryName == "") {
        return(fragData)
    } else {
        write.table(fragData, file = libraryName, sep = "\t", row.names = FALSE, col.names = TRUE, quote = FALSE)
    }
}


setMethod("createVirtualFragmentLibrary",
    signature=signature(chosenGenome="BSgenome", firstCutter="character", secondCutter="character", readLength="numeric"),
    .createVirtualFragmentLibrary_BSgenome)

setMethod("createVirtualFragmentLibrary",
    signature=signature(chosenGenome="DNAString", firstCutter="character", secondCutter="character", readLength="numeric"),
    .createVirtualFragmentLibrary_DNAString)

setMethod("splitChromosome",
    signature=signature(firstCutter="character", secondCutter="character", chromosomeToSplit="DNAString", chromosomeName="character"),
    .splitChromosome_DNAString)

setMethod("createVirtualFragmentLibraryMain",
    signature=signature(totalFragments="data.frame", totalFragmentsRev="data.frame", firstCutter="character", secondCutter="character", readLength="numeric"),
    .createVirtualFragmentLibraryMain)

.checkRestrictionEnzymeSequence <- function(firstCutter, inputFileName, outputFileName = "output.sam", keepOnlyUniqueReads = TRUE, writeStatistics = TRUE) {

    cutterLength = nchar(firstCutter)

    # read lines from specified sam-file
    sam = readLines(inputFileName)

    # initialize statistic variables
    unmapped = 0
    mismatchStart = 0
    mismatchEnd = 0
    incompleteCutter = 0
    totalReads = length(sam)
    mapped = 0
    notUnique = 0

    revCompFirstCutter = toString(reverseComplement(DNAString(firstCutter)))

    for (i in 1:length(sam)) {

        temp = sam[i]

        # check each line if it is a part of the header and use only non-header lines
        if (substr(temp, start = 1, stop = 1) == "@") {
            totalReads = totalReads - 1
        } else {

            # for each line in the sam file that does not belong to the header, split at "TAB"
            split = unlist(strsplit(temp, "\\\t"))

            # get read length and save flag entry
            readLength = nchar(split[10])
            flag = split[2]

            # for now, leave reads without "XT:A:" tag and mark only those with XT:A != U for deletion
            if (keepOnlyUniqueReads) {

                splitUnique = unlist(strsplit(temp, "XT:A:"))
                isNotUnique = FALSE

                if (length(splitUnique) == 2) {
                    if (substr(splitUnique[2], start = 1, stop = 1) != "U") {
                        # not a unique read
                        isNotUnique = TRUE
                    }
                }
            }

            # identify unmapped reads via flag-entry and mark for deletion
            if (intToBits(as.numeric(flag))[3] == 01) {
                unmapped = unmapped + 1
                sam[i] = "toDelete"    
            } else if (keepOnlyUniqueReads == TRUE & isNotUnique == TRUE) {
                notUnique = notUnique + 1
                sam[i] = "toDelete"    
            } else { 
                # mapped read (both strands):
                # 1. check if cutter sequence is complete
                # 2. check if cigar string shows correct mapping (absense of insertion / deletions)  of cutter sequence
                # 3. check if MD string shows correct mapping (absense of SNPs) of cutter sequence

                seq = split[10]
                seqStart = substr(seq, start=1, stop=cutterLength)
                seqEnd = substr(seq, start=readLength-cutterLength+1, stop=readLength)

                if (intToBits(as.numeric(flag))[5] == 00)  {
                    # case a): read maps to forward strand

                    # check if cutter sequence is intact
                    if (seqStart == toupper(firstCutter)) {    

                        startCigar = unlist(strsplit(split[6], "M"))

                        if (nchar(startCigar[1]) < (cutterLength-1)) {
                            # start of string has form XXM or XM -->  no I, D or extended cigar symbols possible
                            if (as.numeric(startCigar[1]) < cutterLength) {
                                # less than (lengthCutter) matches --> cutter sequence not properly mapped --> delete read

                                mismatchStart = mismatchStart + 1
                                sam[i] = "toDelete"
                            } else {
                                # enough matches and complete cutter sequence at start of read (cigar string) --> check MD string for possible SNPs 

                                MDpre = unlist(strsplit(temp, "MD:Z:"))
                                MD = unlist(strsplit(MDpre[2], "\\\t"))[1]

                                MDA = substr(MD[1], start = 1, stop = 1)
                                MDB = substr(MD[1], start = 2, stop = 2)

                                if ((MDB == "A") || (MDB == "G") || (MDB == "C") || (MDB == "T")) {
                                    # start of MD has form XA, XG, XC or XD (X in 0:9) --> check X (number of matches) if at least (cutterLength) matches are present 

                                    if (as.numeric(MDA) < cutterLength) {

                                        mismatchStart = mismatchStart + 1
                                        sam[i] = "toDelete"
                                    } else {
                                        # cutter sequence complete
                                        mapped = mapped + 1
                                    }
                                } else {
                                    # start of MD has form XX (X in 0:9) --> number of matches >= 10 --> enough matches
                                    mapped = mapped + 1
                                }

                            }
                        } else {
                            # insertions, deletions or extended cigar symbols at start of string --> cutter sequence not properly mapped --> delete read

                            mismatchStart = mismatchStart + 1
                            sam[i] = "toDelete"          
                        }

                    } else {
                        # cutter sequence is not intact

                        incompleteCutter = incompleteCutter + 1
                        sam[i] = "toDelete"
                    }

                } else {
                    # case b): read maps to reverse strand

                    if (seqEnd == revCompFirstCutter) {

                        # check end of cigar string: at least (cutterLength; 4 or 6) matches required
                        lCig = nchar(split[6])
                        cigA = substr(split[6], start = lCig-2, stop = lCig-2)
                        cigB = substr(split[6], start = lCig-1, stop = lCig-1)
                        cigC = substr(split[6], start = lCig, stop = lCig)

                        if (cigC != "M") {
                            # end of string has insertions or deletions or extended cigar symbols --> cutter sequence not properly mapped --> delete read
                            sam[i] = "toDelete"

                            mismatchEnd = mismatchEnd + 1

                        } else if ((cigA == "I" || cigA == "D" || cigA == "N" || cigA == "S" || cigA == "H" || cigA == "P") && (as.numeric(cigB) < cutterLength) ){
                            # number of matches at the end of the string is < cutterLength --> cutter sequence not properly mapped --> delete read
                            sam[i] = "toDelete"

                            mismatchEnd = mismatchEnd + 1
                        } else {
                            # >= (cutterLength) mapped bases at the end of the read, complete cutter sequence --> check MD string for possible SNPs

                            MDpre = unlist(strsplit(temp, "MD:Z:"))
                            MD = unlist(strsplit(MDpre[2], "\\\t"))[1]

                            MDA = substr(MD[1], start = readLength-1, stop = readLength-1)
                            MDB = substr(MD[1], start = readLength, stop = readLength)

                            if ((MDA == "A") || (MDA == "G") || (MDA == "C") || (MDA == "T")) {
                                # end of MD has form AX, GX, CX or DX (X in 0:9) --> check X (number of matches) if at least four matches are present

                                if (as.numeric(MDB) < cutterLength) {
                                    mismatchEnd = mismatchEnd + 1
                                    sam[i] = "toDelete"
                                } else {
                                    # cutter sequence complete
                                    mapped = mapped + 1
                                }
                            } else {
                                # end of MD has form XX (X in 0:9) --> number of matches >= 10 --> enough matches
                                mapped = mapped + 1            
                            }

                        }      

                    } else {
                        # cutter sequence not complete: delete read

                        incompleteCutter = incompleteCutter + 1
                        sam[i] = "toDelete"        
                    }      

                }
            }
        }
    }

    # optional: write statistics to additional output file
    if (writeStatistics) {
        totalStats = paste("total reads:", totalReads, sep = " ")
        mappedStats = paste("mapped reads:", mapped, sep = " ")
        unmappedStats = paste("unmapped reads:", unmapped, sep = " ")
        incompleteCutterStats = paste("incomplete cutter:", incompleteCutter, sep = " ")
        mismatchStats = paste("mismatched cutter:", mismatchStart + mismatchEnd, sep = " ")
        notUniqueStats = paste("not unique read:", notUnique, sep = " ")

        statistics = paste(inputFileName, totalStats, mappedStats, unmappedStats, incompleteCutterStats, mismatchStats, notUniqueStats, sep = "\n")

        fileConn = file(sub(".sam", "_statistics.txt", outputFileName))
        writeLines(statistics, fileConn)
        close(fileConn)
    }  

    # filter reads that are marked for deletion
    samNew =  sam[!sam == "toDelete"]

    # write remaining data to specified file
    fileConn = file(outputFileName)
    writeLines(samNew, fileConn)
    close(fileConn)
}




setMethod("checkRestrictionEnzymeSequence",
    signature=signature(firstCutter="character", inputFileName="character"),
    .checkRestrictionEnzymeSequence)

\name{drawDigestionFragmentHistogram}

\alias{drawDigestionFragmentHistogram}
\alias{drawDigestionFragmentHistogram,data.frame-method}

\title{Visualize digestion fragments with a histogram}

\description{
This function is a small convenience function to plot the results of \code{simulateDigestion} as a histogram. Minimum and maximum fragment lengths can be specified to visualize a specified interval of the fragment data.
}

\usage{
    drawDigestionFragmentHistogram(fragments, minLength = 0, maxLength = 10000)
}

\arguments{
    \item{fragments}{Fragment data to visualize (data frame with lengths and corresponding frequencies)}
    \item{minLength}{Minimum fragment length to visualize}
    \item{maxLength}{Maximum fragment length to visualize}
}

\value{Histogram plot of the fragment data}

\examples{
    shortTestGenome = "ATCCATGTAGGCTAAGTACACATGTTAAGGTACAGTACAATTGCACGATCAT"
    fragments = simulateDigestion("catg", "gtac", shortTestGenome)
    drawDigestionFragmentHistogram(fragments)
}

\author{Carolin Walter}

\keyword{drawDigestionFragmentHistogram}

\name{readPointsOfInterestFile}

\alias{readPointsOfInterestFile}
\alias{readPointsOfInterestFile,character-method}

\title{Read a file with coordinates of marker points}

\description{
This small helper function reads a tab-separated file with points of interest information stored in a BED-like format. The file has to provide the columns "chromosome", "start", "end", "name" and "colour" of the regions. The data can then be used for marking the points in near-cis visualization plots, as provided by \code{visualizeViewpoint} and \code{drawHeatmap}.
}

\usage{readPointsOfInterestFile(poiFile)}

\arguments{
    \item{poiFile}{Name of the input file (tab-separated)}
}

\value{Data frame with information on points of interest for the near-cis visualizations}

\examples{
    file <- system.file("extdata", "fetalLiverVP.bed", package="Basic4Cseq")
    pointsOfInterests = readPointsOfInterestFile(file)
    pointsOfInterests
}

\author{Carolin Walter}

\keyword{readPointsOfInterestFile}

\name{liverDataRaw}

\alias{liverDataRaw}

\docType{data}

\title{
    Example 4C-seq data set of fetal liver data 
}

\description{
    This data set contains an instance of a \code{Data4Cseq} object; 2185 reads on 453 fragments are included. Raw reads are mapped to fragments, but the read count has not yet been normalized.
    
    The 4C-seq data was taken from Stadhouders et al's fetal liver data set.
}

\usage{
    data("liverDataRaw")
}

\format{
    Formal class 'Data4Cseq'
}

\source{
    Shortened version of Stadhouders et al's fetal liver data:
    
    Stadhouders, R., Thongjuea, S., et al. (2012): Dynamic long-range chromatin interactions control Myb proto-oncogene transcription during erythroid development. EMBO, 31, 986-999.
}

\examples{
    data("liverDataRaw")
    liverDataRaw
}

\keyword{datasets}

\name{createVirtualFragmentLibrary}

\alias{createVirtualFragmentLibrary}
\alias{createVirtualFragmentLibrary,BSgenome,character,character,numeric-method}
\alias{createVirtualFragmentLibrary,DNAString,character,character,numeric-method}

\title{Create a virtual fragment library from a provided genome and two restriction enzymes}

\description{\pkg{Basic4Cseq} can create virtual fragment libraries from any BSgenome package or DNAString object. Two restriction enzymes have to be specified to cut the DNA, the read length is needed to check the fragment ends of corresponding length for uniqueness. Filter options (minimum and maximum size) are provided on fragment level and on fragment end level.}

\usage{
createVirtualFragmentLibrary(chosenGenome, firstCutter, secondCutter, readLength, onlyNonBlind = TRUE, useOnlyIndex = FALSE, minSize = 0, maxSize = -1, minFragEndSize = 0, maxFragEndSize = 10000000, useAllData = TRUE, chromosomeName = "chr1", libraryName = "default")
}

\arguments{
    \item{chosenGenome}{The genome that is to be digested in silico with the provided enzymes; can be an instance of BSgenome or DNAString}
    \item{firstCutter}{First of two restriction enzymes}
    \item{secondCutter}{Second of two restriction enzymes}
    \item{readLength}{Read length for the experiment}
    \item{onlyNonBlind}{Variable that is TRUE (default) if only non-blind fragments are considered (i.e. all blind fragments are removed)}
    \item{useOnlyIndex}{Convenience function to adapt the annotation style of the chromosomes ("chr1", \dots "chrY" or "1", \dots, "Y"); parameter has to be set to match the BAM file in question}
    \item{minSize}{Filter option that allows to delete fragments below a certain size (in bp)}
    \item{maxSize}{Filter option that allows to delete fragments above a certain size (in bp)}
    \item{minFragEndSize}{Filter option that allows to delete fragment ends below a certain size (in bp)}
    \item{maxFragEndSize}{Filter option that allows to delete fragment ends above a certain size (in bp)}
    \item{useAllData}{Variable that indicates if all data of a BSgenome package is to be used. If FALSE, chromosome names including a "_" are removed, reducing the set of chromosomes to (1 \dots 19, X, Y, MT) for the mouse genome or (1 \dots 22, X, Y, MT) for the human genome}
    \item{chromosomeName}{Chromosome name for the virtual fragment library if a \code{DNAString} object is used instead of a \code{BSgenome} object.}
    \item{libraryName}{Name of the file the created virtual fragment library is written to. Per default the file is called "fragments_firstCutter_secondCutter.csv". The fragment data is returned as a data frame if and only if an empty character string is chosen as \code{libraryName}.}
}

\details{
    \itemize{
        \item \code{readLength} is relevant for the creation of the virtual fragment library to differenciate between unique and non-unique fragment ends. While two fragments can be unique, their respective ends may be repetitive if only the first few bases are considered. For 4C-seq data, reads can only map to the start (or end, respectively) of a 4C-seq fragment, the remaining fragment part is not covered. The length of a fragment end that has to be checked for uniqueness therefore depends on the read length of the experiment.
        \item \code{useAllData} uses the lengths of the chromosomes to identify relevant ones, based on the current BSgenome packages for mm10 or hg19, and may therefore provide undesirable results for smaller genomes with different lengths (i.e. discard all chromosomes).
        \item The length of a fragment influences the expected read count of a 4C-seq fragment. Per default, \pkg{Basic4Cseq} uses the experiment's read length as minimum fragment end size and places virtually no limit on the maximum fragment end size.
    }
}

\value{A tab-separated file with the specified virtual fragment library (containing fragment position, length, presence of second restriction enzyme and uniqueness of the fragment ends)}

\note{
    \itemize{
        \item It is strongly recommended to preprocess and store the virtual fragment library if a number of experiments with the same restriction enzyme combination, read length and underlying genome have to be analyzed.
        \item Processing one of the larger BSgenome packages takes some time and computer data storage.
        \item If no library name for the virtual fragment library is specified, the fragment data is returned as a data frame. If the library name "default" is chosen, the tab-separated file is named "fragments_firstCutter_secondCutter" (with variable cutter sequences).
    }
}

\examples{
    if(interactive()) {
        library(BSgenome.Ecoli.NCBI.20080805)
        fragmentData = createVirtualFragmentLibrary(chosenGenome = Ecoli$NC_002655, firstCutter = "catg", secondCutter = "gtac", readLength = 30,  onlyNonBlind = TRUE, chromosomeName = "NC_002655", libraryName = "fragments_Ecoli.csv")
    }
}

\author{Carolin Walter}

\keyword{createVirtualFragmentLibrary}

\name{printBEDFragmentLibrary}

\alias{printBEDFragmentLibrary}
\alias{printBEDFragmentLibrary,character,character-method}

\title{Print a BED-file fragment library}

\description{
This function extracts the first columns of a virtual fragment library file and exports them as a BED-file for use with other tools (e.g. visualization in the Integrative Genomics Viewer (IGV).)
}

\usage{printBEDFragmentLibrary(fragmentLibrary, BEDLibraryName, minFragEndLength = 0, zeroBased = FALSE)
}

\arguments{
    \item{fragmentLibrary}{Virtual fragment library file name}
    \item{BEDLibraryName}{File name for the exported BED file}
    \item{minFragEndLength}{Minimum fragment end length to be considered}
    \item{zeroBased}{If TRUE, adapt the start of the BED-file fragments}
}

\value{writes BED-file containing the virtual fragment library position data}

\examples{
    if(interactive()) {
        file <- system.file("extdata", "vfl_aagctt_catg_mm9_54_vp.csv", package="Basic4Cseq")
        printBEDFragmentLibrary(file, "BEDLibrary_FL_vp.bed")
    }
}

\author{Carolin Walter}

\keyword{printBEDFragmentLibrary}

\name{normalizeFragmentData}

\alias{normalizeFragmentData}
\alias{normalizeFragmentData,Data4Cseq-method}

\title{Normalize near-cis fragment data read count}

\description{
This function provides a simple RPM (reads per million) normalization for near-cis fragment data read counts of a \code{Data4Cseq} object. A form of normalization is especially important for the comparison of samples with a different read count.
}

\usage{normalizeFragmentData(expData)}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment}
}

\value{Data frame with RPM-normalized data}

\examples{
    data(liverDataRaw)
    normalizedFragments<-normalizeFragmentData(liverDataRaw)
    head(normalizedFragments)
}

\author{Carolin Walter}

\keyword{normalizeFragmentData}

\name{chooseNearCisFragments}

\alias{chooseNearCisFragments}
\alias{chooseNearCisFragments,Data4Cseq,numeric-method}

\title{Choose fragments in a provided region around the viewpoint}

\description{
    This function extracts fragment data from a \code{Data4Cseq} object's \code{rawFragments} slot for visualization with the functions \code{visualizeViewpoint} and \code{drawHeatmap} . Relevant fragments are located within the chosen visualization range; the viewpoint itself can be excluded or included.
}

\usage{chooseNearCisFragments(expData, regionCoordinates, deleteViewpoint = TRUE)}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment, including fragment data for the viewpoint chromosome}
    \item{regionCoordinates}{Interval on the viewpoint chromosome for the intended visualization}
    \item{deleteViewpoint}{If TRUE, delete all fragments that intersect with the experiment's viewpoint interval}
}

\value{A data frame containing the chosen near-cis fragments}

\note{Viewpoint fragments are removed per default to prevent bias through overrepresented sequences caused by self-ligation. These fragments can be included, but should be interpreted with caution.}

\examples{
    # read example data
    data(liverData)
    fragments<-chooseNearCisFragments(liverData, regionCoordinates = c(20800000, 21000000))
    head(fragments)
}

\author{Carolin Walter}

\keyword{chooseNearCisFragments}

\name{importVisualizationFragmentData}

\alias{importVisualizationFragmentData}
\alias{importVisualizationFragmentData,character-method}

\title{Import visualization data from a file}

\description{
This function is a simple helper function that can import near-cis data which was previously exported and stored as tab-separated file.
}

\usage{importVisualizationFragmentData(fileName)}

\arguments{
    \item{fileName}{Name for the tab-separated file with near-cis fragment data}
}

\value{Data frame containing the near-cis fragment data}

\examples{
    file <- system.file("extdata", "fetalLiver_finalFragments.csv", package="Basic4Cseq")
    importVisualizationFragmentData(file)
    head(file)
}

\author{Carolin Walter}

\keyword{importVisualizationFragmentData}

\name{simulateDigestion}

\alias{simulateDigestion}
\alias{simulateDigestion,character,character,character-method}
\alias{simulateDigestion,character,character,BSgenome-method}

\title{Simulate the digestion of a genome}

\description{
This function simulates the digestion process with two restriction enzymes for a dna sequence or a BSgenome package. The information can then be used for quality controls of the biological fragment library.
}

\usage{
    simulateDigestion(firstCutter, secondCutter, dnaSequence)
}

\arguments{
    \item{firstCutter}{First restriction enzyme sequence for the digestion process}
    \item{secondCutter}{Second restriction enzyme sequence for the digestion process}
    \item{dnaSequence}{DNA sequence that is digested}
}

\value{Data frame with lengths and corresponding frequences of fragments}

\details{The resulting virtual library of fragment parts does not provide information on blind or non-blind fragments, but provides information on the fragment length distribution of the real (i.e. biological) 4C-seq library. In contrast to the regular virtual fragment library for 4C-seq data, fragments between two adjacent secondary restriction enzyme sites are counted as well.}

\note{
    \itemize{
        \item The resulting fragment lengths and corresponding frequencies can easily be visualized with R's plot function or the small convenience function \code{drawDigestionFragmentHistogram}
        \item The resulting table of fragment frequencies can easily be exported with R's \code{write.table} function
    }
}

\examples{
    shortTestGenome = "ATCCATGTAGGCTAAGTACACATGTTAAGGTACAGTACAATTGCACGATCAT"
    fragments = simulateDigestion("catg", "gtac", shortTestGenome)
    head(fragments)
}

\author{Carolin Walter}

\keyword{simulateDigestion}

\name{visualizeViewpoint}

\alias{visualizeViewpoint}
\alias{visualizeViewpoint,data.frame-method}
\alias{visualizeViewpoint,Data4Cseq-method}

\title{Draw a near-cis coverage plot for 4C-seq data}

\description{
    This method creates a plot of near-cis 4C-seq fragment data around the experiment's viewpoint. Fragment-based raw data is visualized as grey dots, interpolated data (running median / running mean) as coloured dots. Trend line and quantiles are loess-smoothed; the trend line is shown as colored line whereas the quantiles are depicted as light-grey bands. A corresponding quantile legend is added in an extra plot.
}

\usage{
visualizeViewpoint(expData, poi = data.frame(chr = character(), start = character(), end = character(), name = character(), colour = character()), plotFileName = "", windowLength = 5, interpolationType = "median", picDim = c(9, 5), maxY = -1, minQuantile = 0.2, maxQuantile = 0.8, mainColour = "blue", plotTitle = "4C-seq plot", loessSpan = 0.1, xAxisIntervalLength = 50000, yAxisIntervalLength = 500, useFragEnds = TRUE)
}


\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment, including normalized near-cis fragment data for visualization}
    \item{poi}{Points of interest that will be marked in the plot}
    \item{plotFileName}{Name for the 4C-seq plot file}
    \item{windowLength}{Length of the window for running median / running mean that is used to smooth the trend line}
    \item{interpolationType}{Type of interpolation, either running median or running mean}
    \item{picDim}{Dimensions of the plot}
    \item{maxY}{Maximum y-value to plot. If no maximum is given, the maximum running median / mean value is used}  
    \item{minQuantile}{Minimum quantile to draw}
    \item{maxQuantile}{Maximum quantile to draw}
    \item{mainColour}{Main colour of the plot}
    \item{plotTitle}{Title of the 4C-seq plot, depicted above the main plot}
    \item{loessSpan}{Span value for the loess curve; smaller values mean a tighter fit to the data points, but a value that is too small may produce errors}
    \item{xAxisIntervalLength}{Length of the x axis intervals in the plot}
    \item{yAxisIntervalLength}{Length of the y axis intervals in the plot}
    \item{useFragEnds}{Indicates whether fragment end data is used directly or interpolated on fragment level}
}

\value{A near-cis coverage plot and a corresponding quantile legend}

\note{
PDF export and output as TIFF format are supported. The export format is chosen depending on the plot file name's ending. If no plot file name is provided, the result is plotted on screen.
}

\examples{
    data(liverData)
    file <- system.file("extdata", "fetalLiverVP.bed", package="Basic4Cseq")
        visualizeViewpoint(liverData, readPointsOfInterestFile(file), plotFileName = "", mainColour = "red", plotTitle = "Fetal Liver Near-Cis Plot", loessSpan = 0.1, maxY = 6000, xAxisIntervalLength = 50000, yAxisIntervalLength = 1000)
}

\author{Carolin Walter}

\keyword{visualizeViewpoint}

\name{prepare4CseqData}

\alias{prepare4CseqData}
\alias{prepare4CseqData,character,character,character,character-method}

\title{Alignment and filtering of raw 4C-seq data}

\description{
This function is an optional wrapper for the alignment and preliminary filtering of 4C-seq data. \code{prepare4CseqData} reads a provided 4C-seq fastq file from hard disk. Alignment of the reads is done with BWA, the function \code{checkRestrictionEnzymeSequence} is used for optional filtering. Samtools and bedtools provide the necessary functionality for intersecting the filtered reads with a given 4C-seq fragment library for visualization purposes (e.g. with the Integrative Genomics Viewer, IGV).
}

\usage{prepare4CseqData(fastqFileName, firstCutter, fragmentLibrary, referenceGenome, pathToBWA = "", pathToSam = "", pathToBED = "", controlCutterSequence = FALSE, bwaThreads = 1, minFragEndLength = 0)
}

\arguments{
    \item{fastqFileName}{The name of the fastq file that contains the 4C-seq reads}
    \item{firstCutter}{First cutting enzyme sequence for the 4C-seq experiment, e.g. "AAGCTT"}
    \item{fragmentLibrary}{Name of the fragment library to use for the current 4C-seq experiment; has to correspond to the chosen cutters and chosen genome}
    \item{referenceGenome}{Name (plus path) of the reference genome to use}
    \item{pathToBWA}{Path to BWA}
    \item{pathToSam}{Path to samtools}
    \item{pathToBED}{Path to bedtools}
    \item{controlCutterSequence}{If TRUE, the function \code{checkRestrictionEnzymeSequence} is used to filter non-valid 4C-seq reads}
    \item{bwaThreads}{Number of BWA threads}
    \item{minFragEndLength}{Minimum fragment end length to use for BED export}
}

\value{computes and writes sorted .bam file for the data, as long as BWA, samtools and bedtools are available}

\seealso{\code{\link{checkRestrictionEnzymeSequence}} 
}

\references{
Li, H. and Durbin, R. (2009) Fast and accurate short read alignment with Burrows-Wheeler Transform, Bioinformatics, 25, 1754-60.

Helga Thorvaldsdottir, James T. Robinson, Jill P. Mesirov. Integrative Genomics Viewer (IGV): high-performance genomics data visualization and exploration.  Briefings in Bioinformatics 2012.
}

\examples{
    if(interactive()) {
        # BWA, samtools and bedtools must be installed
        # It is assumed that the example data files (from the package) are in the active directory
        prepare4CseqData("veryShortExample.fastq", "CATG", "veryShortLib.csv", referenceGenome = "veryShortReference.fasta")
    }
}

\author{Carolin Walter}

\keyword{prepare4CseqData}

\name{readsToFragments}

\alias{readsToFragments}
\alias{readsToFragments,Data4Cseq,character-method}

\title{Determine fragment coverage of a 4C-seq fragment library}

\description{
    This function maps aligned reads to fragment ends of the virtual fragment library to calculate the coverage of the fragments. The number of reads at the start and end of a fragment is provided, as well as the average of both fragment ends.
}

\usage{readsToFragments(expData, fragmentLib)}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment, including raw 4C-seq read data}
    \item{fragmentLib}{Fragment library for the given genome and cutting enzyme combination}
}

\value{
    Data frame containing fragment-based data, i.e. a fragment's position and read coverage 
}

\examples{
    data(liverData)
    file <- system.file("extdata", "vfl_aagctt_catg_mm9_54_vp.csv", package="Basic4Cseq")
    rawFragments(liverData) = readsToFragments(liverData, file)
    head(rawFragments(liverData))
}

\author{Carolin Walter}

\keyword{readsToFragments}

\name{exportVisualizationFragmentData}

\alias{exportVisualizationFragmentData}
\alias{exportVisualizationFragmentData,Data4Cseq,character-method}

\title{Export near-cis fragment data of a \code{Data4Cseq} object}

\description{
This function is a simple helper function that writes the near-cis data of a \code{Data4Cseq} object as tab-separated file to hard disk.
}

\usage{exportVisualizationFragmentData(expData, fileName, fullData = FALSE)}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} information on the 4C-seq experiment, including visualization data}
    \item{fileName}{Name for the tab-separated file}
    \item{fullData}{If TRUE, the function exports the full fragment data (including fragment end length etc). If FALSE, only the minimum fragment information is exported, i.e. chromosome, start, end and (normalized) read count.}
}

\value{A tab-separated file containing near-cis framgent data of a \code{Data4Cseq} object}

\examples{
    if(interactive()) {
        data(liverData)
        exportVisualizationFragmentData(liverData, "fetalLiverData.csv")
    }
}

\author{Carolin Walter}

\keyword{exportVisualizationFragmentData}

\name{printWigFile}

\alias{printWigFile}
\alias{printWigFile,Data4Cseq-method}

\title{Print a wig file from 4C-seq read data}

\description{
This function provides wig files from filtered fragment data. Only reads on unique frag-ends are considered for the export. Export of wig files with a fixed span length requires a uniform read length throughout the data.

While some tools (e.g. the Integrative Genomics Viewer, IGV) accept 'raw' wig data, the UCSC browser needs a header line for correct visualizations. A basic header line has the form 'track type=wiggle_0', but may also contain information on the track's name and a short description. Since the header line may complicate possible downstream analysis of the wig files, no header is included per default.   
}

\usage{printWigFile(expData, wigFileName = "output.wig", fixedSpan = TRUE, headerUCSC = "", useOnlyIndex = FALSE)
}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment}
    \item{wigFileName}{Name of the wig file that is written to hard disk}
    \item{fixedSpan}{If TRUE, use a fixed span for the wig file}
    \item{headerUCSC}{A header line for the UCSC browser}
    \item{useOnlyIndex}{If TRUE, use only '1,2,...Y' as chromosome names, if FALSE, use 'chr1,chr2...chrY'.}
}

\value{A wig file containing the experiment's reads}

\references{
UCSC Genome Browser: Kent WJ, Sugnet CW, Furey TS, Roskin KM, Pringle TH, Zahler AM, Haussler D. The human genome browser at UCSC. Genome Res. 2002 Jun;12(6):996-1006. 

http://genome.ucsc.edu/
}

\examples{
    if(interactive()) {
        data(liverData)
        printWigFile(liverData, wigFileName = "fetalLiver.wig")
    }
}

\author{Carolin Walter}

\keyword{printWigFile}

\name{giveEnzymeSequence}

\alias{giveEnzymeSequence}
\alias{giveEnzymeSequence,character,character-method}

\title{Provide the corresponding enzyme sequence for an enzyme name}

\description{
This function is a small convenience function that reads in a prepared file with restriction enzyme sequence names and sequences. \code{giveEnzymeSequence} then provides restriction enzyme sequences for the example enzymes listed in van de Werken et al's 4Cseqpipe data base. 
}

\usage{giveEnzymeSequence(fileNameDatabase, enzymeName)}

\arguments{
    \item{fileNameDatabase}{File name of the prepared enzyme database}
    \item{enzymeName}{Name of the enzyme for which the sequence is to be returned}
}

\value{Character string with the restriction enzyme sequence}

\references{van de Werken, H., Landan, G., Holwerda, S., et al. (2012): Robust 4C-seq data analysis to screen for regulatory DNA interactions, Nature Methods, 9, 969-971.}

\note{For any custom-made enzyme list it is assumed that there are no duplicate enzyme names in the database.}

\examples{
    file <- system.file("extdata", "enzymeData.csv", package="Basic4Cseq")  
    giveEnzymeSequence(file, "NlaIII")
}

\author{Carolin Walter}

\keyword{giveEnzymeSequence}

\name{drawHeatmap}

\alias{drawHeatmap}
\alias{drawHeatmap,Data4Cseq-method}
\alias{drawHeatmap,data.frame-method}

\title{Draw a heatmap-like multi-scale contact profile}

\description{
This method draws a fragment-based heatmap-like plot for 4C-seq data around a given viewpoint. For a given number of bands, color-coded running medians or running means of signal intensity (normalized and log-scaled) in different fragments are displayed; the window size of the running medians or running means increases from top to bottom. A corresponding colour legend is added in an extra plot.
}

\usage{
    \S4method{drawHeatmap}{Data4Cseq}(expData, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE)
    \S4method{drawHeatmap}{data.frame}(expData, plotFileName = "", smoothingType = "median", picDim = c(9, 2.2), bands = 5, cutoffLog = -7.0, xAxisIntervalLength = 50000, legendLabels = expression(2^-7, 2^0), useFragEnds = TRUE)
}

\arguments{
    \item{expData}{Experiment data from a given 4C-seq experiment for visualization; can be a \code{Data4Cseq} object or a data frame}
    \item{plotFileName}{Name for the heatmap plot}
    \item{smoothingType}{Type of interpolation (running mean or running median). Default value is "median" (i.e. running median)}
    \item{picDim}{Dimensions of the plot. Default value is c(9, 2.2), to fit a small heatmap plot below the main 4C-seq plot that is created by \code{visualizeViewpoint}}
    \item{bands}{Number of coloured "bands" (rows) to visualize. The first band contains the raw data (running median or running mean with window size 1), the following bands increase in window size (+2 per band)}
    \item{cutoffLog}{Cut off value for the logarithmic scale}
    \item{xAxisIntervalLength}{Length of the x axis intervals in the plot}
    \item{legendLabels}{Labels for a heat colour legend plot; labels should correspond to the logarithmic cut offs}
    \item{useFragEnds}{Indicates whether fragment end data is used directly or interpolated on fragment level}
}

\value{A multiscale intensity contact profile plot and a corresponding colour legend)}

\note{
PDF export and output as TIFF format are supported. The export format is chosen depending on the plot file name's ending. If no plot file name is provided, the result is plotted on screen.
}

\examples{
    if(interactive()) {
        data(liverData)
        drawHeatmap(liverData)
    }
}

\author{Carolin Walter}

\keyword{drawHeatmap}

\name{Data4Cseq-class}

\docType{class}
\alias{Data4Cseq-class}
\alias{viewpointChromosome}
\alias{viewpointChromosome,Data4Cseq-method}
\alias{viewpointChromosome<-}
\alias{viewpointChromosome<-,Data4Cseq,character-method}
\alias{viewpointInterval}
\alias{viewpointInterval,Data4Cseq-method}
\alias{viewpointInterval<-}
\alias{viewpointInterval<-,Data4Cseq,numeric-method}
\alias{readLength}
\alias{readLength,Data4Cseq-method}
\alias{readLength<-}
\alias{readLength<-,Data4Cseq,numeric-method}
\alias{pointsOfInterest}
\alias{pointsOfInterest,Data4Cseq-method}
\alias{pointsOfInterest<-}
\alias{pointsOfInterest<-,Data4Cseq,data.frame-method}
\alias{rawReads}
\alias{rawReads,Data4Cseq-method}
\alias{rawReads<-}
\alias{rawReads<-,Data4Cseq,GAlignments-method}
\alias{rawFragments}
\alias{rawFragments,Data4Cseq-method}
\alias{rawFragments<-}
\alias{rawFragments<-,Data4Cseq,data.frame-method}
\alias{nearCisFragments}
\alias{nearCisFragments,Data4Cseq-method}
\alias{nearCisFragments<-}
\alias{nearCisFragments<-,Data4Cseq,data.frame-method}

\title{Class \code{"Data4Cseq"}}
\description{
This class is a container for information on a specific 4C-seq experiment. Stored information includes raw reads, fragment data, and the experiment's viewpoint location.
}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("Data4Cseq", ...)}.
}

\section{Slots}{
    \describe{
        \item{\code{viewpointChromosome}:}{Object of class \code{"character"} representing the viewpoint chromosome's name}
        \item{\code{viewpointInterval}:}{Object of class \code{"numeric"} representing the viewpoint interval's location}
        \item{\code{readLength}:}{Object of class \code{"numeric"} representing the experiment's read length}
        \item{\code{pointsOfInterest}:}{Object of class \code{"data.frame"} representing any points of interest to be marked in the near-cis visualizations}
        \item{\code{rawReads}:}{Object of class \code{"GAlignments"} representing the raw 4C-seq reads of the experiment}
        \item{\code{rawFragments}:}{Object of class \code{"data.frame"} representing the experiment's corresponding virtual fragment library}
        \item{\code{nearCisFragments}:}{Object of class \code{"data.frame"} representing near-cis data in fragment form}
    }
}

\section{Methods}{
    \describe{
        \item{viewpointChromosome<-}{\code{signature(object = "Data4Cseq", value = "character")}: 
        Setter-method for the viewpointChromosome slot.}
        \item{viewpointChromosome}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the viewpointChromosome slot.}
        \item{viewpointInterval<-}{\code{signature(object = "Data4Cseq", value = "numeric")}: 
        Setter-method for the viewpointInterval slot.}
        \item{viewpointInterval}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the viewpointInterval slot.}
        \item{readLength<-}{\code{signature(object = "Data4Cseq", value = "numeric")}: 
        Setter-method for the readLength slot.}
        \item{readLength}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the readLength slot.}
        \item{pointsOfInterest<-}{\code{signature(object = "Data4Cseq", value = "data.frame")}: 
        Setter-method for the pointsOfInterest slot.}
        \item{pointsOfInterest}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the pointsOfInterest slot.}
        \item{rawReads<-}{\code{signature(object = "Data4Cseq", value = "GAlignments")}: 
        Setter-method for the rawReads slot.}
        \item{rawReads}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the rawReads slot.}
        \item{rawFragments<-}{\code{signature(object = "Data4Cseq", value = "data.frame")}: 
        Setter-method for the rawFragments slot.}
        \item{rawFragments}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the rawFragments slot.}
        \item{nearCisFragments<-}{\code{signature(object = "Data4Cseq", value = "data.frame")}: 
        Setter-method for the nearCisFragments slot.}
        \item{nearCisFragments}{\code{signature(object = "Data4Cseq")}: 
        Getter-method for the nearCisFragments slot.}
    }
}

\author{
Carolin Walter
}

\examples{
showClass("Data4Cseq")
}

\keyword{classes}

\name{plotTransInteractions}

\alias{plotTransInteractions}
\alias{plotTransInteractions,character,character,numeric,character-method}
\alias{plotTransInteractions,data.frame,character,numeric,data.frame-method}

\title{Visualize trans interaction intervals}

\description{
This function visualizes trans interaction intervals of a 4C-seq experiment with the help of the \pkg{RCircos} package. Significant interactions can be obtained by use of Splinter et al's \code{significant_interactions} code or similar algorithms.
}

\usage{
plotTransInteractions(interactionFile, chromosomeViewpoint, coordViewpoint, ideogramData, PlotColor = "default", expandBands = FALSE, expansionValue = 0, plotFileName = "", picDim = c(8, 8))
}

\arguments{
    \item{interactionFile}{Interaction interval data; either a file name or a data frame}
    \item{chromosomeViewpoint}{Viewpoint chromosome of the 4C-seq experiment}
    \item{coordViewpoint}{Viewpoint coordinates of the 4C-seq experiment}
    \item{ideogramData}{Ideogram data to be visualized in the RCirco-plot; either a file name or a data frame}
    \item{PlotColor}{Plot colours for the visualized interactions}
    \item{expandBands}{If TRUE, add a specified value to the size of the interaction intervals to increase the visibility of very small interactions}
    \item{expansionValue}{Value that is added to each interaction interval end}
    \item{plotFileName}{Optional name for an output file}
    \item{picDim}{Dimensions of the plot}
}

\value{An RCircos-plot of trans interaction intervals}

\details{The code of Splinter et al to determine significant interactions provides chromosome, start and end of interaction intervals and a forth column with information on far-cis or trans data. This column is ignored by \code{plotTransInteractions}; it is assumed that all interactions for trans visualization are indeed trans interactions. Otherwise, far-cis interactions are visualized as well. While not a mistake per se, the (usually more numerous) far-cis interactions are easier to interpret if visualized with Splinter et al's spider-plot functions.}

\note{
PDF export and output as TIFF format are supported. The export format is chosen depending on the plot file name's ending. If no plot file name is provided, the result is plotted on screen.
}

\references{
Zhang, H., Meltzer, P. and Davis, S. (2013) RCircos: an R package for Circos 2D track plots, BMC Bioinformatics, 14, 244

Splinter, E., de Wit, E., van de Werken, H., et al. (2012) Determining long-range chromatin interactions for selected genomic sites using 4C-seq technology: From fixation to computation, Methods, 58, 221-230.
}

\examples{
    if(interactive()) {
        library(RCircos)
        interactions <- system.file("extdata", "transInteractionData.txt", package="Basic4Cseq")
        ideograms <- system.file("extdata", "RCircos_GRCm38_ideogram.csv", package="Basic4Cseq")
        plotTransInteractions(interactions, "10", c(20000042, 20001000), ideograms, PlotColor = "blue", expandBands = TRUE, expansionValue = 1000000, plotFileName = "")
    }
}

\author{Carolin Walter}

\keyword{plotTransInteractions}

\name{Data4Cseq}

\alias{Data4Cseq}
\alias{Data4Cseq,character,numeric,numeric,data.frame,GAlignments-method}
\alias{Data4Cseq,character,numeric,numeric,missing,missing-method}


\title{Creating a Data4Cseq object}

\description{
    This function creates a Data4Cseq object. Data on the 4C-seq experiment, e.g. the chromosome of the viewpoint, is stored and checked for consistency.
}

\usage{Data4Cseq(viewpointChromosome, viewpointInterval, readLength, pointsOfInterest, rawReads)}

\arguments{
    \item{viewpointChromosome}{The experiment's viewpoint chromosome}
    \item{viewpointInterval}{The interval of the experiment's viewpoint, consisting of a start and end coordinate}
    \item{readLength}{The experiment's read length (in base pairs)}
    \item{pointsOfInterest}{Points of interest to be marked in a near-cis visualization}
    \item{rawReads}{Reads of the 4C-seq experiment, aligned and stored as an \code{GAlignments} object}
}

\details{
    A \code{Data4Cseq} object contains basic information for the corresponding 4C-seq experiment, including the viewpoint chromosome, the viewpoint region and reads from the experiment. See \code{\link{Data4Cseq-class}} for more details. The constructor collects the basic data; fragment data or normalized read counts are added later.   

Fragments at the experiment's viewpoint are usually vastly overrepresented due to self-ligation; \code{chooseNearCisFragments} offers the option to discard all fragments in the specified viewpoint region. The specified viewpoint interval of a \code{Data4Cseq} object is supposed to correspond to the positions of the biological primers on the genome, but can also be increased in size if more fragments around the viewpoint should be removed.
}

\value{
    An instance of the Data4Cseq class.
}

\seealso{
    \code{\link{Data4Cseq-class}}
}

\examples{
    # create a Data4Cseq object with a minimum of data
    liverData = Data4Cseq(viewpointChromosome = "10", viewpointInterval = c(20879870, 20882209), readLength = 54)
    liverData

    # create a Data4Cseq object, including possible points of interest and raw reads 
    bamFile <- system.file("extdata", "fetalLiverShort.bam", package="Basic4Cseq")
    liverReads <- readGAlignments(bamFile)
    pointsOfInterestFile <- system.file("extdata", "fetalLiverVP.bed", package="Basic4Cseq")
    liverData = Data4Cseq(viewpointChromosome = "10", viewpointInterval = c(20879870, 20882209), readLength = 54, pointsOfInterest = readPointsOfInterestFile(pointsOfInterestFile), rawReads = liverReads)
    liverData
}

\author{Carolin Walter}

\keyword{Data4Cseq}

\name{getReadDistribution}

\alias{getReadDistribution}
\alias{getReadDistribution,Data4Cseq-method}

\title{Calculate the read distribution for a 4C-seq experiment}

\description{
This function provides some 4C-seq quality statistics based on the experiment's read distribution throughout the genome. \code{getReadDistribution} calculates the number of total reads, cis to overall ratio of reads, and the percentage of covered fragment ends within a certain distance around the experiment's viewpoint. Reference values for high-quality experiments, as provided by van de Werken et al, 2012, are more than one million reads total, a cis to overall ratio of more than 40\% and a large fraction of covered fragment ends in the viewpoint's vicinity. 
}

\usage{getReadDistribution(expData, distanceFromVP = 100000, useFragEnds = TRUE, outputName = "")
}

\arguments{
    \item{expData}{Experiment data of class \code{Data4Cseq} with information on the 4C-seq experiment}
    \item{distanceFromVP}{Distance from the viewpoint that is checked for covered fragments}
    \item{useFragEnds}{If TRUE, the function uses fragment end data; if FALSE, an average value for whole fragments is used.}
    \item{outputName}{An optional name for an output text file containing the statistics data}
}

\value{Text with statistics data on the 4C-seq experiment}

\references{van de Werken, H., de Vree, P., Splinter, E., et al. (2012): 4C technology: protocols and data analysis, Methods Enzymology, 513, 89-112}

\note{
Text export is supported; if no file name is provided, the results are printed on screen.
}

\examples{
    data(liverData)
    getReadDistribution(liverData)
}

\author{Carolin Walter}

\keyword{getReadDistribution}

\name{checkRestrictionEnzymeSequence}

\alias{checkRestrictionEnzymeSequence}
\alias{checkRestrictionEnzymeSequence,character,character-method}

\title{Remove invalid 4C-seq reads from a SAM file}

\description{
\pkg{Basic4Cseq} offers filter functions for invalid 4C-seq reads. This function removes 4C-seq reads from a provided Sequence Alignment/Map (SAM) file that show mismatches in the restriction enzyme sequence. 
}

\usage{checkRestrictionEnzymeSequence(firstCutter, inputFileName, outputFileName = "output.sam", keepOnlyUniqueReads = TRUE, writeStatistics = TRUE)}

\arguments{
    \item{firstCutter}{First restriction enzyme sequence of the 4C-seq experiment}
    \item{inputFileName}{Name of the input SAM file that contains aligned reads for the 4C-seq experiment}
    \item{outputFileName}{Name of the output SAM file that is created to store the filtered 4C-seq reads}
    \item{keepOnlyUniqueReads}{If TRUE, delete non-unique reads. Information in the SAM flag field is used to determine whether a read is unique or not.}
    \item{writeStatistics}{If TRUE, write statistics (e.g. the number of unique reads) to a text file}
}

\details{
Valid 4C-seq reads start at a primary restriction site and continue with its downstream sequence, so any mismatch in the restriction enzyme sequence of a read is an indicator for a mismatch. The mapping information of the restriction enzyme sequence bases of a read (if present) can be used for filtering purposes. \code{checkRestrictionEnzymeSequence} tests the first bases of a read (depending on the length of the first restriction enzyme either 4 or 6 bp long) for mismatches. Reads with mismatches in the restriction enzyme sequence are deleted, the filtered data is then written to a new SAM file. The function does not yet differentiate between blind and nonblind fragments, but removes potential misalignments that may overlap with valid fragment ends and distort the true 4C-seq signal.
}

\value{A SAM file containing the filtered valid 4C-seq reads}

\note{The use of the function is only possible if the restriction enzyme sequence is not trimmed or otherwise absent.}

\examples{
    if(interactive()) {
        file <- system.file("extdata", "fetalLiverCutter.sam", package="Basic4Cseq")
        checkRestrictionEnzymeSequence("aagctt", file)
    }
}

\author{Carolin Walter}

\keyword{checkRestrictionEnzymeSequence}
